<?php
/* * *****************************************************************************************
 *                                                                                          *
 *  CAO-Faktura für Windows Version 1.4 (http://www.cao-faktura.de)                         *
 *  Copyright (C) 2003 Jan Pokrandt / Jan@JP-SOFT.de                                        *
 *                                                                                          *
 *  This program is free software; you can redistribute it and/or                           *
 *  modify it under the terms of the GNU General Public License                             *
 *  as published by the Free Software Foundation; either version 2                          *
 *  of the License, or any later version.                                                   *
 *                                                                                          *
 *  This program is distributed in the hope that it will be useful,                         *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of                          *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                           *
 *  GNU General Public License for more details.                                            *
 *                                                                                          *
 *  You should have received a copy of the GNU General Public License                       *
 *  along with this program; if not, write to the Free Software                             *
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                                          *
 *  ******* This Scripts comes with ABSOLUTELY NO WARRANTY ***************                  *
 *                                                                                          *
 * *******************************************************************************************
 *                                                                                          *
 * Eine Entfernung oder Veraenderung dieses Dateiheaders ist nicht zulaessig !!!            *
 * Wenn Sie diese Datei veraendern dann fuegen Sie ihre eigenen Copyrightmeldungen          *
 * am Ende diese Headers an                                                                 *
 *                                                                                          *
 * *******************************************************************************************
 *                                                                                          *
 *  Programm     : CAO-Faktura                                                              *
 *  Modul        : cao_xtc.php                                                              *
 *  Stand        : 25.04.2008                                                               *
 *  Version      : 1.55                                                                     *
 *  Beschreibung : Script zum Datenaustausch CAO-Faktura <--> xtCommerce-Shop               *
 *                                                                                          *
 *  based on:                                                                               *
 * (c) 2000 - 2001 The Exchange Project                                                     *
 * (c) 2001 - 2003 osCommerce, Open Source E-Commerce Solutions                             *
 * (c) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plänkers                                      *
 * (c) 2003 JP-Soft, Jan Pokrandt                                                           *
 * (c) 2003 IN-Solution, Henri Schmidhuber                                                  *
 * (c) 2003 www.websl.de, Karl Langmann                                                     *
 * (c) 2003 RV-Design Raphael Vullriede                                                     *
 * (c) 2004 XT-Commerce                                                                     *
 *                                                                                          *
 * Released under the GNU General Public License                                            *
 *                                                                                          *
 * History :                                                                                *
 *                                                                                          *
 * - 26.09.2005 JP Funktionen aus xml_export.php und cao_import.php erstellt                *
 * - 04.10.2005 JP/KL Version 1.44 released, Scripte komplett ueberarbeitet                 *
 * - 06.10.2005 KL/JP Bugfix bei xtc_set_time_limit                                         *
 * - 17.10.2005 JP Bugfixes fuer XTC 304                                                    *
 * - 21.10.2005 KL/JP Bugfix fuer XTC 2.x Spalte products_Ean angelegt                      *
 * - 23.10.2005 hartleib Fehlende $LangID in OrderUpdate hinzugefuegt                       *
 * - 02.11.2005 JP Fehler bei doppelter Funktion xtDBquery gefixt                           *
 * - 07.11.2005 JP Export Orders/VAT_ID implementiert                                       *
 * - 15.09.2006 xsell_update / erase durch Wolfgang eingebaut                               *
 *              siehe : http://www.cao-faktura.de/index.php?option=com_forum&               *
 *              Itemid=44&page=viewtopic&p=52192#52192                                      *
 * - 18.09.2006 JP Export Shop->CAO Artikel/PRODUCTS_EAN hinzugefuegt                       *
 *              Ansicht des Transfer-Logs eingebaut                                         *
 * - 16.04.2006 JP Export Products um Image1,Image2 und VPE erweitert                       *
 * - 17.11.2009 AR Update Product um Image1 und Image2 erweitert                            *
 *              (ursprünglicher Code stammt von Burn aus dem CAO Forum)                     *
 * - 18.11.2009 AR Export Products: PRODUCT_QUANTITY immer als Ganzzahl exportieren         *
 * - 29.12.2010 CM Sprachinfos bei Versionsabruf mit ausgeben                               *
 *              Kundengruppenname bei Bestellabruf übermitteln                              *
 *              Generell mehr 12 Bilder unterstützen                                        *
 * - 14.01.2011 CM $LangID in $DefaultLangID umbenannt                                      *
 * ***************************************************************************************** */

if (!function_exists('xtDBquery')) :

    function xtDBquery($query) {
        //	if (DB_CACHE == 'true')
        //	{
        //		$result = xtc_db_queryCached($query);
        //	}
        //	  else
        //	{
        $result = xtc_db_query($query);
        //	}
        return $result;
    }

endif;

//--------------------------------------------------------------

function SendScriptVersion() {
    global $_GET, $version_nr, $version_datum;

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<STATUS>' . "\n" .
        '<STATUS_DATA>' . "\n" .
        '<ACTION>' . $_GET['action'] . '</ACTION>' . "\n" .
        '<CODE>' . '111' . '</CODE>' . "\n" .
        '<SCRIPT_VER>' . $version_nr . '</SCRIPT_VER>' . "\n" .
        '<SCRIPT_DATE>' . $version_datum . '</SCRIPT_DATE>' . "\n" .
        '</STATUS_DATA>' . "\n" .
        // Hinzugefügt am 29.12.2010 von CM:
        '<LANGUAGES>' . "\n";

    // Geändert am 23.12.2010 von CM: Sprachinformationen ausgeben für Unterstützung mehrerer Sprachen
    $languages_query = xtc_db_query("select languages_id, code from " . TABLE_LANGUAGES . " order by sort_order");
    while ($languages = xtc_db_fetch_array($languages_query)) {
        $langCode = strtoupper($languages['code']);
        $schema .= "<LANG><CODE>" . $langCode . "</CODE><ID>" . $languages['languages_id'] . "</ID></LANG>\n";
    }
    $schema .= '</LANGUAGES>' . "\n" .
        '</STATUS>' . "\n\n";

    echo $schema;
}

//--------------------------------------------------------------

// Geändert am 11.07.2011 von CM: Default Parameter, damit die Werte nicht immer leer übergeben werden müssen + ProductCount
//function print_xml_status($code, $action, $msg, $mode, $item, $value) {
function print_xml_status($code, $action, $msg, $mode = "", $item = "", $value = "", $productCount = "", $categoriesCount = "", $pwch = "", $pwtype = "") {
    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<STATUS>' . "\n" .
        '<STATUS_DATA>' . "\n" .
        '<CODE>' . $code . '</CODE>' . "\n" .
        '<ACTION>' . $action . '</ACTION>' . "\n" .
        '<MESSAGE>' . $msg . '</MESSAGE>' . "\n";

    if (strlen($mode) > 0)
        $schema .= '<MODE>' . $mode . '</MODE>' . "\n";

    if (strlen($item) > 0)
        $schema .= '<' . $item . '>' . $value . '</' . $item . '>' . "\n";
    
    if(strlen($productCount) > 0)
        $schema .= "<PRODUCTS_TOTAL_COUNT>" . $productCount . "</PRODUCTS_TOTAL_COUNT>\n";

    if(strlen($categoriesCount) > 0)
        $schema .= "<CATEGORIES_TOTAL_COUNT>" . $categoriesCount . "</CATEGORIES_TOTAL_COUNT>\n";
    
    if($msg == "WRONG PASSWORD")
    {
        $schema .= "<PWCH>" . $pwch . "</PWCH>\n";
        $schema .= "<PWTYPE>" . $pwtype . "</PWTYPE>\n";
    }
    
    $schema .= '</STATUS_DATA>' . "\n" .
        '</STATUS>' . "\n\n";

    echo $schema;

    return;
}

function print_xml_resultset_status($code, $action, $msg, $results)
{
    echo "<?xml version='1.0' encoding='utf-8'?>\n"
       . "<STATUS>\n<STATUS_DATA>\n"
       . "<CODE>" . $code . "</CODE>\n"
       . "<ACTION>" . $action . "</ACTION>\n"
       . "<MESSAGE>" . $msg . "</MESSAGE>\n";

    foreach($results as $res)
    {
        echo "<RESULTS>"
            ."<CODE>" . $res["CODE"] . "</CODE>\n"
            ."<MESSAGE>" . $res["MESSAGE"] . "</MESSAGE>\n"
            ."<CORRELATION_ID>" . $res["CORRELATION_ID"] . "</CORRELATION_ID>\n"
            ."</RESULTS>";
    }

    echo "</STATUS_DATA>\n</STATUS>\n";
}

//--------------------------------------------------------------

function table_exists($table_name) {
    $res = xtc_db_query("show tables like '" . $table_name . "'");
    if (xtc_db_num_rows($res) <= 0) {
        return(false);
    } else {
        return(true);
    }
}

//--------------------------------------------------------------

function column_exists($table, $column) {
    $res = xtc_db_query("show columns from $table LIKE '" . $column . "'");
    if (xtc_db_num_rows($res) <= 0) {
        return(false);
    } else {
        return(true);
    }
}

function get_column_max_length($table, $column)
{
    $res = xtc_db_query("show columns from $table LIKE '" .$column . "'");
    if($row = xtc_db_fetch_array($res))
    {
        $type = $row['Type'];
        $matches = array();
        preg_match('/\\((.*)\\)/', $type, $matches);
        if(count($matches) == 2)
            return intval($matches[1]);
    }
    
    return 0;
}

//--------------------------------------------------------------

// Hinzugefügt am 04.05.2012 von CM: Abfragen der Anzahl zum blockweisen Übertragen der Kategorien
function SendCategoriesCount(){
    global $db;

    $res = xtc_db_query("SELECT COUNT(*) AS Count FROM " . TABLE_CATEGORIES);
    $cnt = 0;
    if($row = xtc_db_fetch_array($res))
        $cnt= $row["Count"];

    print_xml_status(0,$_POST["action"], "", "", "", "", "", $cnt);
}

function SendCategories() {
    if (defined('SET_TIME_LIMIT')) {
        @set_time_limit(0);
    }

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<CATEGORIES>' . "\n";

    echo $schema;

    // Geändert am 04.05.2012 von CM: Blockweises Abfragen ermöglichen
    // $cat_query = xtc_db_query("select categories_id, categories_image, parent_id, sort_order, date_added, last_modified " .
    //        " from " . TABLE_CATEGORIES . " order by parent_id, categories_id");
    $sql = "select categories_id, categories_image, parent_id, sort_order, date_added, last_modified from " . TABLE_CATEGORIES . " order by parent_id, categories_id";
    
    $from = xtc_db_prepare_input($_GET['from']);
    $anz = xtc_db_prepare_input($_GET['count']);
    if (isset($from)) {
        if (!isset($anz))
            $anz = 1000;
        $sql .= " limit " . $from . "," . $anz;
   }
    $cat_query = xtc_db_query($sql);
    
    while ($cat = xtc_db_fetch_array($cat_query)) {
        $schema = '<CATEGORIES_DATA>' . "\n" .
            '<ID>' . $cat['categories_id'] . '</ID>' . "\n" .
            '<PARENT_ID>' . $cat['parent_id'] . '</PARENT_ID>' . "\n" .
            '<IMAGE_URL>' . xtc_htmlspecialchars($cat['categories_image']) . '</IMAGE_URL>' . "\n" .
            '<SORT_ORDER>' . $cat['sort_order'] . '</SORT_ORDER>' . "\n" .
            '<DATE_ADDED>' . $cat['date_added'] . '</DATE_ADDED>' . "\n" .
            '<LAST_MODIFIED>' . $cat['last_modified'] . '</LAST_MODIFIED>' . "\n";

        $detail_query = xtc_db_query("select categories_id, language_id,
                                  categories_name,
                                  categories_heading_title,
                                  categories_description,
                                  categories_meta_title,
                                  categories_meta_description,
                                  categories_meta_keywords, " . TABLE_LANGUAGES . ".code as lang_code, " . TABLE_LANGUAGES . ".name as lang_name from " . TABLE_CATEGORIES_DESCRIPTION . "," . TABLE_LANGUAGES .
                " where " . TABLE_CATEGORIES_DESCRIPTION . ".categories_id=" . $cat['categories_id'] . " and " . TABLE_LANGUAGES . ".languages_id=" . TABLE_CATEGORIES_DESCRIPTION . ".language_id");

        while ($details = xtc_db_fetch_array($detail_query)) {
            $schema .= "<CATEGORIES_DESCRIPTION ID='" . $details["language_id"] . "' CODE='" . $details["lang_code"] . "' NAME='" . $details["lang_name"] . "'>\n";
            $schema .= "<NAME>" . xtc_htmlspecialchars($details["categories_name"]) . "</NAME>" . "\n";
            $schema .= "<HEADING_TITLE>" . xtc_htmlspecialchars($details["categories_heading_title"]) . "</HEADING_TITLE>" . "\n";
            $schema .= "<DESCRIPTION>" . xtc_htmlspecialchars($details["categories_description"]) . "</DESCRIPTION>" . "\n";
            $schema .= "<META_TITLE>" . xtc_htmlspecialchars($details["categories_meta_title"]) . "</META_TITLE>" . "\n";
            $schema .= "<META_DESCRIPTION>" . xtc_htmlspecialchars($details["categories_meta_description"]) . "</META_DESCRIPTION>" . "\n";
            $schema .= "<META_KEYWORDS>" . xtc_htmlspecialchars($details["categories_meta_keywords"]) . "</META_KEYWORDS>" . "\n";
            $schema .= "</CATEGORIES_DESCRIPTION>\n";
        }

        // Geändert am 18.05.2012 von CM: Nur ausgeben, wenn wirklich benötigt
        if($_GET['skip_product_assignments'] != 'true')
        {
            // Produkte in dieser Categorie auflisten
            // Geändert am 08.03.2010 von CM: Artikel-Nummer übergeben
            $prod2cat_query = xtc_db_query("select categories_id, " . TABLE_PRODUCTS_TO_CATEGORIES . ".products_id, products_model from " . TABLE_PRODUCTS_TO_CATEGORIES .
                    " left join " . TABLE_PRODUCTS . " on (" . TABLE_PRODUCTS_TO_CATEGORIES . ".products_id = " . TABLE_PRODUCTS . ".products_id )" .
                    " where categories_id='" . $cat['categories_id'] . "'");

            while ($prod2cat = xtc_db_fetch_array($prod2cat_query)) {
                $schema .="<PRODUCTS ID='" . $prod2cat["products_id"] . "' MODEL='" . xtc_htmlspecialchars($prod2cat["products_model"]) . "'></PRODUCTS>" . "\n";
            }
        }
        
        $schema .= '</CATEGORIES_DATA>' . "\n";
        echo $schema;
    }
    $schema = '</CATEGORIES>' . "\n";
    echo $schema;
}

//--------------------------------------------------------------

function SendManufacturers() {
    if (defined('SET_TIME_LIMIT')) {
        @set_time_limit(0);
    }

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<MANUFACTURERS>' . "\n";
    echo $schema;

    $cat_query = xtc_db_query("select manufacturers_id, manufacturers_name, manufacturers_image, date_added, last_modified " .
            " from " . TABLE_MANUFACTURERS . " order by manufacturers_id");

    while ($cat = xtc_db_fetch_array($cat_query)) {
        $schema = '<MANUFACTURERS_DATA>' . "\n" .
            '<ID>' . $cat['manufacturers_id'] . '</ID>' . "\n" .
            '<NAME>' . xtc_htmlspecialchars($cat['manufacturers_name']) . '</NAME>' . "\n" .
            '<IMAGE>' . xtc_htmlspecialchars($cat['manufacturers_image']) . '</IMAGE>' . "\n" .
            '<DATE_ADDED>' . $cat['date_added'] . '</DATE_ADDED>' . "\n" .
            '<LAST_MODIFIED>' . $cat['last_modified'] . '</LAST_MODIFIED>' . "\n";

        $sql = "select
             manufacturers_id, " .
            TABLE_MANUFACTURERS_INFO . ".languages_id,
             manufacturers_url, 
             url_clicked, 
             date_last_click, " .
            TABLE_LANGUAGES . ".code as lang_code, " .
            TABLE_LANGUAGES . ".name as lang_name
            from " .
            TABLE_MANUFACTURERS_INFO . "," .
            TABLE_LANGUAGES . "
            where " .
            TABLE_MANUFACTURERS_INFO . ".manufacturers_id=" . $cat['manufacturers_id'] . " and " .
            TABLE_LANGUAGES . ".languages_id=" . TABLE_MANUFACTURERS_INFO . ".languages_id";

        $detail_query = xtc_db_query($sql);

        while ($details = xtc_db_fetch_array($detail_query)) {
            $schema .= "<MANUFACTURERS_DESCRIPTION ID='" . $details["languages_id"] . "' CODE='" . $details["lang_code"] . "' NAME='" . $details["lang_name"] . "'>\n";
            $schema .= "<URL>" . xtc_htmlspecialchars($details["manufacturers_url"]) . "</URL>" . "\n";
            $schema .= "<URL_CLICK>" . $details["url_clicked"] . "</URL_CLICK>" . "\n";
            $schema .= "<DATE_LAST_CLICK>" . $details["date_last_click"] . "</DATE_LAST_CLICK>" . "\n";
            $schema .= "</MANUFACTURERS_DESCRIPTION>\n";
        }
        $schema .= '</MANUFACTURERS_DATA>' . "\n";
        echo $schema;
    }
    $schema = '</MANUFACTURERS>' . "\n";
    echo $schema;
}

//--------------------------------------------------------------

function SendOrders() {
    global $order_total_class, $MerchantCustomerGroupID;

    $order_from = xtc_db_prepare_input($_GET['order_from']);
    
    // Hinzugefügt am 21.08.2012 von CM: Steuerbar ob Händlerbestellungen mit Netto oder Brutto-Preisen übergeben werden
    // Geändert am 31.08.2012 von CM: Funktionalität entfernt -> immer Brutto übergeben
    //$AddVatAmountOnMerchantOrders = true;
    //If(isset($_GET["add_vat_amount_on_merchant_orders"]))
    //    $AddVatAmountOnMerchantOrders = $_GET["add_vat_amount_on_merchant_orders"] != 0;

    if (defined('SET_TIME_LIMIT')) {
        @set_time_limit(0);
    }

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<ORDER>' . "\n";
    echo $schema;

    $sql = "select * from " . TABLE_ORDERS . " where orders_id >= '" . xtc_db_input($order_from) . "'";

    $orders_query = xtc_db_query($sql);

    while ($orders = xtc_db_fetch_array($orders_query)) {
        // Geburtsdatum laden
        $cust_sql = "select * from " . TABLE_CUSTOMERS . " where customers_id=" . $orders['customers_id'];
        $cust_query = xtc_db_query($cust_sql);
        if (($cust_query) && ($cust_data = xtc_db_fetch_array($cust_query))) {
            // Hinzugefügt am 03.11.2011 von CM: Fax-Nummer steht in der Tabelle Customers
            $cust_fax = $cust_data['customers_fax'];
            
            $cust_dob = $cust_data['customers_dob'];
            $cust_gender = $cust_data['customers_gender'];
        } else {
            // Hinzugefügt am 03.11.2011 von CM: Fax-Nummer steht in der Tabelle Customers
            $cust_fax = '';
            
            $cust_dob = '';
            $cust_gender = '';
        }

        // Geändert am 08.10.2009 von AR: Wenn in der Rechnungsadresse die Postleitzahl fehlt, die komplette Lieferanschrift als Rechnungsadresse verwenden
        /*
          if ($orders['billing_company']=='') $orders['billing_company']=$orders['delivery_company'];
          if ($orders['billing_name']=='')  $orders['billing_name']=$orders['delivery_name'];
          if ($orders['billing_street_address']=='') $orders['billing_street_address']=$orders['delivery_street_address'];
          if ($orders['billing_postcode']=='')  $orders['billing_postcode']=$orders['delivery_postcode'];
          if ($orders['billing_city']=='')  $orders['billing_city']=$orders['delivery_city'];
          if ($orders['billing_suburb']=='') $orders['billing_suburb']=$orders['delivery_suburb'];
          if ($orders['billing_state']=='')  $orders['billing_state']=$orders['delivery_state'];
          if ($orders['billing_country']=='')  $orders['billing_country']=$orders['delivery_country'];
         */

        if ($orders['billing_postcode'] == '') {
            $orders['billing_company'] = $orders['delivery_company'];
            $orders['billing_name'] = $orders['delivery_name'];
            $orders['billing_street_address'] = $orders['delivery_street_address'];
            $orders['billing_postcode'] = $orders['delivery_postcode'];
            $orders['billing_city'] = $orders['delivery_city'];
            $orders['billing_suburb'] = $orders['delivery_suburb'];
            $orders['billing_state'] = $orders['delivery_state'];
            $orders['billing_country'] = $orders['delivery_country'];
        }

        $schema = '<ORDER_INFO>' . "\n" .
            '<ORDER_HEADER>' . "\n" .
            '<ORDER_ID>' . $orders['orders_id'] . '</ORDER_ID>' . "\n" .
            '<CUSTOMER_ID>' . $orders['customers_id'] . '</CUSTOMER_ID>' . "\n" .
            '<CUSTOMER_CID>' . $orders['customers_cid'] . '</CUSTOMER_CID>' . "\n" .
            '<CUSTOMER_GROUP>' . $orders['customers_status'] . '</CUSTOMER_GROUP>' . "\n" .
            // Hinzugefügt am 29.12.2010 von CM: Kundengruppen-Namen senden (customers_status_name)
            '<CUSTOMER_GROUP_NAME>' . xtc_htmlspecialchars($orders['customers_status_name']) . '</CUSTOMER_GROUP_NAME>' . "\n" .
            '<ORDER_DATE>' . $orders['date_purchased'] . '</ORDER_DATE>' . "\n" .
            '<ORDER_STATUS>' . xtc_htmlspecialchars($orders['orders_status']) . '</ORDER_STATUS>' . "\n" .
            '<ORDER_IP>' . $orders['customers_ip'] . '</ORDER_IP>' . "\n" .
            '<ORDER_CURRENCY>' . xtc_htmlspecialchars($orders['currency']) . '</ORDER_CURRENCY>' . "\n" .
            '<ORDER_CURRENCY_VALUE>' . $orders['currency_value'] . '</ORDER_CURRENCY_VALUE>' . "\n" .
            '</ORDER_HEADER>' . "\n" .
			// Geändert am 2018-10-01 von CM: Gambio und xtcmod haben für die BuyerMessage eine extra Spalte
			'<ORDER_COMMENTS>' . xtc_htmlspecialchars($orders['comments']) . '</ORDER_COMMENTS>' . "\n" .
			
            '<BILLING_ADDRESS>' . "\n" .
            '<VAT_ID>' . xtc_htmlspecialchars($orders['customers_vat_id']) . '</VAT_ID>' . "\n" . //JP07112005 (Existiert erst ab XTC 3.x)
            '<COMPANY>' . xtc_htmlspecialchars($orders['billing_company']) . '</COMPANY>' . "\n" .
            '<NAME>' . xtc_htmlspecialchars($orders['billing_name']) . '</NAME>' . "\n" .
            '<FIRSTNAME>' . xtc_htmlspecialchars($orders['billing_firstname']) . '</FIRSTNAME>' . "\n" .
            '<LASTNAME>' . xtc_htmlspecialchars($orders['billing_lastname']) . '</LASTNAME>' . "\n" .
            '<STREET>' . xtc_htmlspecialchars($orders['billing_street_address']) . '</STREET>' . "\n" .
            '<POSTCODE>' . xtc_htmlspecialchars($orders['billing_postcode']) . '</POSTCODE>' . "\n" .
            '<CITY>' . xtc_htmlspecialchars($orders['billing_city']) . '</CITY>' . "\n" .
            '<SUBURB>' . xtc_htmlspecialchars($orders['billing_suburb']) . '</SUBURB>' . "\n" .
            '<STATE>' . xtc_htmlspecialchars($orders['billing_state']) . '</STATE>' . "\n" .
            '<COUNTRY>' . xtc_htmlspecialchars($orders['billing_country_iso_code_2']) . '</COUNTRY>' . "\n" .
            '<TELEPHONE>' . xtc_htmlspecialchars($orders['customers_telephone']) . '</TELEPHONE>' . "\n" . // JAN
            '<EMAIL>' . xtc_htmlspecialchars($orders['customers_email_address']) . '</EMAIL>' . "\n" . // JAN
            '<BIRTHDAY>' . xtc_htmlspecialchars($cust_dob) . '</BIRTHDAY>' . "\n" .
            '<GENDER>' . xtc_htmlspecialchars($cust_gender) . '</GENDER>' . "\n" .
            // Hinzugefügt am 03.11.2011 von CM: Fax-Nummer übergeben
            '<FAX>'. xtc_htmlspecialchars($cust_fax) . '</FAX>' . "\n" .
            '</BILLING_ADDRESS>' . "\n" .
            '<DELIVERY_ADDRESS>' . "\n" .
            '<COMPANY>' . xtc_htmlspecialchars($orders['delivery_company']) . '</COMPANY>' . "\n" .
            '<NAME>' . xtc_htmlspecialchars($orders['delivery_name']) . '</NAME>' . "\n" .
            '<FIRSTNAME>' . xtc_htmlspecialchars($orders['delivery_firstname']) . '</FIRSTNAME>' . "\n" .
            '<LASTNAME>' . xtc_htmlspecialchars($orders['delivery_lastname']) . '</LASTNAME>' . "\n" .
            '<STREET>' . xtc_htmlspecialchars($orders['delivery_street_address']) . '</STREET>' . "\n" .
            '<POSTCODE>' . xtc_htmlspecialchars($orders['delivery_postcode']) . '</POSTCODE>' . "\n" .
            '<CITY>' . xtc_htmlspecialchars($orders['delivery_city']) . '</CITY>' . "\n" .
            '<SUBURB>' . xtc_htmlspecialchars($orders['delivery_suburb']) . '</SUBURB>' . "\n" .
            '<STATE>' . xtc_htmlspecialchars($orders['delivery_state']) . '</STATE>' . "\n" .
            '<COUNTRY>' . xtc_htmlspecialchars($orders['delivery_country_iso_code_2']) . '</COUNTRY>' . "\n" .
            // Hinzugefügt am 03.11.2011 von CM: Fax-Nummer übergeben + Telefonnummer auch in Lieferadresse übergeben
            '<FAX>'. xtc_htmlspecialchars($cust_fax) . '</FAX>' . "\n" .
            '<TELEPHONE>' . xtc_htmlspecialchars($orders['customers_telephone']) . '</TELEPHONE>' . "\n" . 
                
            '</DELIVERY_ADDRESS>' . "\n" .
            '<PAYMENT>' . "\n" .
            '<PAYMENT_METHOD>' . xtc_htmlspecialchars($orders['payment_method']) . '</PAYMENT_METHOD>' . "\n" .
            '<PAYMENT_CLASS>' . xtc_htmlspecialchars($orders['payment_class']) . '</PAYMENT_CLASS>' . "\n";

        switch ($orders['payment_class']) {
            case 'banktransfer':
                $bank_query = xtc_db_query("select * from " . TABLE_BANKTRANSFER . " where orders_id = " . $orders['orders_id']);  
                if($bank = xtc_db_fetch_array($bank_query))
                {
                    $schema .= '<PAYMENT_BANKTRANS_BNAME>' . xtc_htmlspecialchars($bank['banktransfer_bankname']) . '</PAYMENT_BANKTRANS_BNAME>' . "\n" .
                    '<PAYMENT_BANKTRANS_BLZ>' . xtc_htmlspecialchars($bank['banktransfer_blz']) . '</PAYMENT_BANKTRANS_BLZ>' . "\n" .
                    '<PAYMENT_BANKTRANS_NUMBER>' . xtc_htmlspecialchars($bank['banktransfer_number']) . '</PAYMENT_BANKTRANS_NUMBER>' . "\n" .
                    '<PAYMENT_BANKTRANS_OWNER>' . xtc_htmlspecialchars($bank['banktransfer_owner']) . '</PAYMENT_BANKTRANS_OWNER>' . "\n";
                    
                    if(array_key_exists('banktransfer_iban', $bank))
                    {
                        $schema .= '<PAYMENT_BANKTRANS_IBAN>' . xtc_htmlspecialchars($bank['banktransfer_iban']) . '</PAYMENT_BANKTRANS_IBAN>' . "\n" .
                        '<PAYMENT_BANKTRANS_BIC>' . xtc_htmlspecialchars($bank['banktransfer_bic']) . '</PAYMENT_BANKTRANS_BIC>' . "\n";
                    }
                }
                break;
            case 'paypal':
			case 'paypal3':
                if(table_exists(TABLE_PAYPAL))
                {
                    $paypal_query = xtc_db_query("SELECT txn_id FROM " . TABLE_PAYPAL . " WHERE xtc_order_id = " . $orders['orders_id']);
                    while($paypal = xtc_db_fetch_array($paypal_query))
                    {
                        if(preg_match('/^[0-9A-Z]*$/', $paypal['txn_id']))
                        {
                            $schema .= '<PAYMENT_TRANSACTION_ID>' . $paypal['txn_id'] . '</PAYMENT_TRANSACTION_ID>';
                            break;
                        }
                    }
                }
				else if(table_exists(TABLE_ORDERS_PAYPAL_PAYMENTS))
				{
					$paypal_query = xtc_db_query("SELECT payment_id FROM " . TABLE_ORDERS_PAYPAL_PAYMENTS . " WHERE orders_id = " . $orders['orders_id']);
					if($paypal = xtc_db_fetch_array($paypal_query))
						$schema .= '<PAYMENT_TRANSACTION_ID>' . $paypal['payment_id'] . '</PAYMENT_TRANSACTION_ID>';
				}
                break;
            case 'sepa':
                if(table_exists(TABLE_SEPA))
                {                   
                    $sepa_query = xtc_db_query("SELECT * FROM " . TABLE_SEPA . " WHERE orders_id = " . $orders['orders_id']);   
                    if($sepa = xtc_db_fetch_array($sepa_query))
                    {
                        $schema .= '<PAYMENT_BANKTRANS_BNAME>' . xtc_htmlspecialchars($sepa['sepa_bankname']) . '</PAYMENT_BANKTRANS_BNAME>' . "\n" .
                                '<PAYMENT_BANKTRANS_OWNER>' . xtc_htmlspecialchars($sepa['sepa_owner']) . '</PAYMENT_BANKTRANS_OWNER>' . "\n" .
                                '<PAYMENT_BANKTRANS_IBAN>' . xtc_htmlspecialchars($sepa['sepa_iban']) . '</PAYMENT_BANKTRANS_IBAN>' . "\n" .
                                '<PAYMENT_BANKTRANS_BIC>' . xtc_htmlspecialchars($sepa['sepa_bic']) . '</PAYMENT_BANKTRANS_BIC>' . "\n";
                    }
                }
                break;
        }
        $schema .= '</PAYMENT>' . "\n" .
            '<SHIPPING>' . "\n" .
            '<SHIPPING_METHOD>' . xtc_htmlspecialchars($orders['shipping_method']) . '</SHIPPING_METHOD>' . "\n" .
            '<SHIPPING_CLASS>' . xtc_htmlspecialchars($orders['shipping_class']) . '</SHIPPING_CLASS>' . "\n";
			
			// Hinzugefügt am 2019-04-15 von CM: DHL Wunschpaket
			if(substr($orders['shipping_class'],0,8) == "dhlgkapi")
			{
				preg_match('/[\[~]PD:([^\]~]+)/', $orders['shipping_method'], $preferred_day);
				preg_match('/[\[~]PT:([^\]~]+)/', $orders['shipping_method'], $preferred_time);
				preg_match('/[\[~]PL:([^\]~]+)/', $orders['shipping_method'], $preferred_location);
				preg_match('/[\[~]PN:([^\]~]+)/', $orders['shipping_method'], $preferred_neighbor);
				
				if(!empty($preferred_day))
					$schema .= "<SHIPPING_PREFERRED_DAY>" . xtc_htmlspecialchars($preferred_day[1]) . "</SHIPPING_PREFERRED_DAY>\n";
				if(!empty($preferred_time))
					$schema .= "<SHIPPING_PREFERRED_TIME>" . xtc_htmlspecialchars($preferred_time[1]) . "</SHIPPING_PREFERRED_TIME>\n";
				if(!empty($preferred_location))
					$schema .= "<SHIPPING_PREFERRED_LOCATION>" . xtc_htmlspecialchars($preferred_location[1]) . "</SHIPPING_PREFERRED_LOCATION>\n";
				if(!empty($preferred_neighbor))
					$schema .= "<SHIPPING_PREFERRED_NEIGHBOR>" . xtc_htmlspecialchars($preferred_neighbor[1]) . "</SHIPPING_PREFERRED_NEIGHBOR>\n";
				
			}

        $schema .= '</SHIPPING>' . "\n" .
            '<ORDER_PRODUCTS>' . "\n";

        $sql = "select
             orders_products_id,
             allow_tax, 
             products_id, 
             products_model, 
             products_name, 
             final_price, 
             products_tax, 
             products_quantity 
            from " .
            TABLE_ORDERS_PRODUCTS . "
            where 
             orders_id = '" . $orders['orders_id'] . "'";

        $AllowTax = true;
        $PriceSumByVatPercent = array();
        
        $products_query = xtc_db_query($sql);
        while ($products = xtc_db_fetch_array($products_query)) {
            // Geändert am 06.04.2008 von AR: Immer Brutto Betrag verwenden
            //if ($products['allow_tax']==1) $products['final_price']=$products['final_price']/(1+$products['products_tax']*0.01);
            // Geändert am 11.06.2009 von AR: Für Auction Studio immer Brutto Betrag verwenden. Bei Händlern (customer_status = 3) MWSt hinzu rechnen
            // Geändert am 24.01.2012 von CM: wenn allow_tax == 0 dann MwSt hinzu rechnen
            //if ($orders['customers_status'] == 3)
            // Geändert am 03.07.2012 von CM: Preise sind bei Händler-Bestellungen normal übergeben, das entfernen der MwSt sollte später in AS nach einer Prüfung erfolgen
            //if ($orders['customers_status'] == 3 || $products['allow_tax'] == 0)
            //    $products['final_price'] = $products['final_price'] * (1 + $products['products_tax'] * 0.01);

            if($products["allow_tax"] == 0)
            {
                // Hinzugefügt am 21.08.2012 von CM: Jeh nach Einstellung die Netto-Priese hoch rechnen oder als Netto übergeben
                // Geändert am 31.08.2012 von CM: Funktionalität entfernt -> immer Brutto übergeben
                //if($AddVatAmountOnMerchantOrders)
                //    $products['final_price'] = round($products['final_price'] * (1 + $products['products_tax'] * 0.01),2);
                //else
                //    $products['products_tax'] = 0;
                $products['final_price'] = round($products['final_price'] * (1 + $products['products_tax'] * 0.01),2);
                
                $AllowTax = false;
            }
            
            // Hinzugefügt am 21.08.2012 von CM: Daten zum berechnen der MwSt für die Versandkosten aus der Hauptleistung sammeln
            $PriceSumByVatPercent[$products['products_tax']] += $products["final_price"];
            
            $schema .= '<PRODUCT>' . "\n" .
                '<PRODUCTS_ID>' . $products['products_id'] . '</PRODUCTS_ID>' . "\n" .
                '<PRODUCTS_QUANTITY>' . $products['products_quantity'] . '</PRODUCTS_QUANTITY>' . "\n" .
                // Geändert am 15.07.2011 von CM: wenn es Sich um eine Variante handelt muss Products_Model die Lagerhaltungsnummer der Variante zurück geben
                //'<PRODUCTS_MODEL>' . xtc_htmlspecialchars($products['products_model']) . '</PRODUCTS_MODEL>' . "\n" .
                '<PRODUCTS_NAME>' . xtc_htmlspecialchars($products['products_name']) . '</PRODUCTS_NAME>' . "\n" .
                '<PRODUCTS_PRICE>' . $products['final_price'] / $products['products_quantity'] . '</PRODUCTS_PRICE>' . "\n" .
                // Geändert am 03.07.2012 von CM: AS interpretiert TaxFlag nicht
                // -> Mit 0% übergeben, wenn der Käufer in der Händler-Gruppe ist und allow_tax == false
                //'<PRODUCTS_TAX>' . $products['products_tax'] . '</PRODUCTS_TAX>' . "\n" .
                //'<PRODUCTS_TAX_FLAG>' . $products['allow_tax'] . '</PRODUCTS_TAX_FLAG>' . "\n";
                '<PRODUCTS_TAX>' . $products["products_tax"] . '</PRODUCTS_TAX>' . "\n";

            $products_model = $products['products_model'];

            $sql = "SELECT oa.products_options, oa.products_options_values, oa.options_values_price, oa.price_prefix, pa.attributes_model FROM " . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . " oa "
                                          . " INNER JOIN " . TABLE_PRODUCTS_OPTIONS . " po ON po.products_options_name = products_options "
                                          . " INNER JOIN " . TABLE_PRODUCTS_OPTIONS_VALUES . " pov ON pov.products_options_values_name = products_options_values "
                                          . " INNER JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa ON pa.options_id = po.products_options_id AND pa.options_values_id = pov.products_options_values_id"
                    // Geändert am 07.11.2011 von CM: Zusätzlich nach der ProduktId suchen, da sonst mehrere Attribute in frage kommen
                                          //. " WHERE orders_id = '" . $orders['orders_id'] . "' AND orders_products_id = '" . $products['orders_products_id'] . "'";
                    . " WHERE orders_id = '" . $orders['orders_id'] . "' AND orders_products_id = '" . $products['orders_products_id'] . "' AND pa.products_id = '" . $products['products_id'] . "'";

            $attributes_query = xtc_db_query($sql);
            
            if (xtc_db_num_rows($attributes_query)) {
                while ($attributes = xtc_db_fetch_array($attributes_query)) {
                    $schema .= '<OPTION>' . "\n"
                        . '<PRODUCTS_OPTIONS>' . xtc_htmlspecialchars($attributes['products_options']) . '</PRODUCTS_OPTIONS>' . "\n"
                        . '<PRODUCTS_OPTIONS_VALUES>' . xtc_htmlspecialchars($attributes['products_options_values']) . '</PRODUCTS_OPTIONS_VALUES>' . "\n"
                        . '</OPTION>' . "\n";

                    // Geändert am 18.07.2011 von CM: Wird der Shop nicht von Auction Studio verwaltet werden die Lagerhaltungsnummern des Attributes standardmäsig
                    //      einfach an die Lagerhaltungsnummer des Haupt-Artikels angehängt.
                    if(strtolower($_GET["return_combined_refcodes_in_sales"]) == "true")
                        $products_model .= $attributes['attributes_model'];
                    else
                        $products_model = $attributes['attributes_model'];
                }
            }
            
            if(table_exists(TABLE_GM_GPRINT_ORDERS_ELEMENTS))
            {
                $sql = "SELECT oe.name, oe.elements_value, oe.group_type FROM " . TABLE_GM_GPRINT_ORDERS_ELEMENTS . " oe "
                    . " INNER JOIN " . TABLE_GM_GPRINT_ORDERS_SURFACES . " os ON oe.gm_gprint_orders_surfaces_id = os.gm_gprint_orders_surfaces_id "
                    . " INNER JOIN " . TABLE_GM_GPRINT_ORDERS_SURFACES_GROUPS . " osg ON os.gm_gprint_orders_surfaces_groups_id = osg.gm_gprint_orders_surfaces_groups_id"
                    . " WHERE osg.orders_products_id = '" . $products['orders_products_id'] . "'";
                
                $gx_customizer_query = xtc_db_query($sql);
                while($attributes = xtc_db_fetch_array($gx_customizer_query))
                {
                    //statische Felder überspringen, nur Benutzereingaben übergeben
                    if($attributes["group_type"] == "text" || $attributes["group_type"] == "image")
                        continue;
                    
                    $schema .= '<OPTION>' . "\n"
                        . '<PRODUCTS_OPTIONS>' . xtc_htmlspecialchars($attributes["name"]) . '</PRODUCTS_OPTIONS>' . "\n"
                        . '<PRODUCTS_OPTIONS_VALUES>' . xtc_htmlspecialchars($attributes["elements_value"]) . '</PRODUCTS_OPTIONS_VALUES>' . "\n"
                        . '</OPTION>' . "\n";
                }
            }
            

            $schema .= '<PRODUCTS_MODEL>' . xtc_htmlspecialchars($products_model) . '</PRODUCTS_MODEL>' . "\n"
                    . '</PRODUCT>' . "\n";
        }
        $schema .= '</ORDER_PRODUCTS>' . "\n";
        $schema .= '<ORDER_TOTAL>' . "\n";

        $totals_query = xtc_db_query("select title, value, class, sort_order from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . $orders['orders_id'] . "' order by sort_order");
        while ($totals = xtc_db_fetch_array($totals_query)) {
            
            $vatPercent = 19;
            
            if($totals["class"] == "ot_shipping")
            {
                // Hinzugefügt am 21.08.2012 von CM: MwSt der Versandkosten anhand der Hauptleistung
                if(count($PriceSumByVatPercent) > 0)
                {
                    arsort($PriceSumByVatPercent);
                    $listVatPercent = array_keys($PriceSumByVatPercent);
                    $vatPercent = $listVatPercent[0];
                }
                
                // Hinzugefügt am 21.08.2012 von CM: Jeh nach Einstellung die Netto-Priese hoch rechnen oder als Netto übergeben
                if(!$AllowTax)
                {
                    // Geändert am 31.08.2012 von CM: Funktionalität entfernt -> immer Brutto übergeben
                    //if($AddVatAmountOnMerchantOrders)
                    //    $totals['value'] = round($totals['value'] * (1 + $vatPercent * 0.01),2);
                    //else
                    //    $vatPercent = 0;
                    $totals['value'] = round($totals['value'] * (1 + $vatPercent * 0.01),2);
                }
                
            }
            
            // Geändert am 13.06.2013 von CM: Wenn vom Versandservice keine Versandkosten eingetragen wurde, kann Auction Studio die Bestellung nicht importieren
            $value = xtc_htmlspecialchars($totals['value']);
            if(empty($value))
                    $value = '0';
           
            $schema .= '<TOTAL>' . "\n" .
                '<TOTAL_TITLE>' . xtc_htmlspecialchars($totals['title']) . '</TOTAL_TITLE>' . "\n" .
                '<TOTAL_VALUE>' . $value . '</TOTAL_VALUE>' . "\n" .
                '<TOTAL_CLASS>' . xtc_htmlspecialchars($totals['class']) . '</TOTAL_CLASS>' . "\n" .
                '<TOTAL_SORT_ORDER>' . xtc_htmlspecialchars($totals['sort_order']) . '</TOTAL_SORT_ORDER>' . "\n" .
                '<TOTAL_TAX>' . $vatPercent . '</TOTAL_TAX>' . "\n" .
                '</TOTAL>' . "\n";
        }
        $schema .= '</ORDER_TOTAL>' . "\n";
        $schema .= '</ORDER_INFO>' . "\n\n";
        echo $schema;
    }
    $schema = '</ORDER>' . "\n\n";
    echo $schema;
}

//--------------------------------------------------------------

function SendProductsCount(){
    global $db;

    $res = xtc_db_query("SELECT COUNT(*) AS Count FROM " . TABLE_PRODUCTS);
    $cnt = 0;
    if($row = xtc_db_fetch_array($res))
        $cnt= $row["Count"];

    print_xml_status(0,$_POST["action"], "", "", "", "", $cnt);
}

function SendProducts() {
    global $_GET, $DefaultLangID;

    if (defined('SET_TIME_LIMIT')) {
        @set_time_limit(0);
    }

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<PRODUCTS>' . "\n";
    echo $schema;

    // Geändert am 11.07.2011 von CM: Hersteller-Namen abfragen
    $sql = "select p.products_id,products_fsk18, products_quantity, products_model, products_image, products_price, " .
        "products_ean, products_date_added, products_last_modified, products_date_available, products_weight, " .
        "products_status, products_tax_class_id, m.manufacturers_id, products_ordered, m.manufacturers_name";

    // Geändert am 29.12.2010 von CM: immer mehr bilder übergeben
    //if ((defined('TABLE_PRODUCTS_IMAGES')) and (USE_3IMAGES==true))
    // Geändert am 11.07.2011 von CM: Werden über zusätzliche Bilder exportiert
    //if (defined('TABLE_PRODUCTS_IMAGES')) {
    //    $sql .= ",pi1.image_name as image_1, pi2.image_name as image_2";
    //}

    if ((defined('TABLE_PRODUCTS_VPE')) and (USE_VPE == true)) {
        $sql .=",products_vpe_name";
    }

    $sql .=" from " . TABLE_PRODUCTS . " as p ";

    // Geändert am 11.07.2011 von CM:
    $sql .= " LEFT JOIN " . TABLE_MANUFACTURERS . " m ON (m.manufacturers_id = p.manufacturers_id) ";

    // Geändert am 29.12.2010 von CM: immer mehr bilder übergeben
    //if ((defined('TABLE_PRODUCTS_IMAGES')) and (USE_3IMAGES==true))
    // Geändert am 11.07.2011 von CM: Werden über zusätzliche Bilder exportiert
    //if (defined('TABLE_PRODUCTS_IMAGES')) {
    //    $sql .= "left outer join " . TABLE_PRODUCTS_IMAGES . " pi1 on pi1.products_id = p.products_id and pi1.image_nr=1 " .
    //        "left outer join " . TABLE_PRODUCTS_IMAGES . " pi2 on pi2.products_id = p.products_id and pi2.image_nr=2 ";
    //}

    if ((defined('TABLE_PRODUCTS_VPE')) and (USE_VPE == true)) {
        $sql .="left outer join " . TABLE_PRODUCTS_VPE . " on p.products_vpe = " . TABLE_PRODUCTS_VPE . ".products_vpe_id and " . TABLE_PRODUCTS_VPE . ".language_id=" . $DefaultLangID;
    }


    $from = xtc_db_prepare_input($_GET['products_from']);
    $anz = xtc_db_prepare_input($_GET['products_count']);
    if (isset($from)) {
        if (!isset($anz))
            $anz = 1000;
        $sql .= " limit " . $from . "," . $anz;
    }

    $orders_query = xtc_db_query($sql);
    while ($products = xtc_db_fetch_array($orders_query)) {

        // Geändert am 09.09.2011 von CM: quantity, tax_rate, price und weight dürfen nicht leer sein
        $quantity = floor($products['products_quantity']);
        $price = $products['products_price'];

        if(empty($quantity)) $quantity = 0;
        if(empty($price)) $price = 0;

        $schema = '<PRODUCT_INFO>' . "\n" .
            '<PRODUCT_DATA>' . "\n" .
            '<PRODUCT_ID>' . $products['products_id'] . '</PRODUCT_ID>' . "\n" .
            /*               '<PRODUCT_DEEPLINK>'. HTTP_SERVER.DIR_WS_CATALOG.$xtc_filename['product_info'].'?products_id='.$products['products_id'].'</PRODUCT_DEEPLINK>' . "\n" . */
            '<PRODUCT_QUANTITY>' . $quantity . '</PRODUCT_QUANTITY>' . "\n" .
            '<PRODUCT_MODEL>' . xtc_htmlspecialchars($products['products_model']) . '</PRODUCT_MODEL>' . "\n" .
            '<PRODUCT_FSK18>' . xtc_htmlspecialchars($products['products_fsk18']) . '</PRODUCT_FSK18>' . "\n" .
            '<PRODUCT_IMAGE>' . xtc_htmlspecialchars($products['products_image']) . '</PRODUCT_IMAGE>' . "\n" .
            '<PRODUCT_EAN>' . xtc_htmlspecialchars($products['products_ean']) . '</PRODUCT_EAN>' . "\n";

        // Geändert am 29.12.2010 von CM: immer mehr bilder übertragen
        //if ((defined('TABLE_PRODUCTS_IMAGES')) and (USE_3IMAGES==true))
        if (defined('TABLE_PRODUCTS_IMAGES')) {
            $schema .= '<PRODUCT_IMAGE_MED>' . xtc_htmlspecialchars($products['image_1']) . '</PRODUCT_IMAGE_MED>' . "\n" .
                '<PRODUCT_IMAGE_LARGE>' . xtc_htmlspecialchars($products['image_2']) . '</PRODUCT_IMAGE_LARGE>' . "\n";
        }

        if ((defined('TABLE_PRODUCTS_VPE')) and (USE_VPE == true)) {
            $schema .= '<PRODUCT_VPE>' . xtc_htmlspecialchars($products['products_vpe_name']) . '</PRODUCT_VPE>' . "\n";
        }

        if (file_exists('cao_sendprod_1.php')) {
            include('cao_sendprod_1.php');
        }

        $schema .= '<PRODUCT_PRICE>' . $price . '</PRODUCT_PRICE>' . "\n";

        require_once(DIR_FS_INC . 'xtc_get_tax_rate.inc.php');

        if (SWITCH_MWST == 'true') {
            // switch IDs
            if ($products['products_tax_class_id'] == 1) {
                $products['products_tax_class_id'] = 2;
            } else {
                if ($products['products_tax_class_id'] == 2) {
                    $products['products_tax_class_id'] = 1;
                }
            }
        }

        $weight = $products['products_weight'];
        $tax_rate = xtc_get_tax_rate($products['products_tax_class_id']);

        if(empty($weight)) $weight = 0;
        if(empty($tax_rate)) $tax_rate = 0;

        $schema .= '<PRODUCT_WEIGHT>' . $weight . '</PRODUCT_WEIGHT>' . "\n" .
            '<PRODUCT_STATUS>' . $products['products_status'] . '</PRODUCT_STATUS>' . "\n" .
            '<PRODUCT_TAX_CLASS_ID>' . $products['products_tax_class_id'] . '</PRODUCT_TAX_CLASS_ID>' . "\n" .
            '<PRODUCT_TAX_RATE>' . $tax_rate . '</PRODUCT_TAX_RATE>' . "\n" .
            '<MANUFACTURERS_ID>' . $products['manufacturers_id'] . '</MANUFACTURERS_ID>' . "\n" .
        // Geändert am 11.07.2011 von CM: Hersteller
            '<MANUFACTURERS_NAME>' . xtc_htmlspecialchars($products['manufacturers_name']) . '</MANUFACTURERS_NAME>' . "\n" .
        
            '<PRODUCT_DATE_ADDED>' . $products['products_date_added'] . '</PRODUCT_DATE_ADDED>' . "\n" .
            '<PRODUCT_LAST_MODIFIED>' . $products['products_last_modified'] . '</PRODUCT_LAST_MODIFIED>' . "\n" .
            '<PRODUCT_DATE_AVAILABLE>' . $products['products_date_available'] . '</PRODUCT_DATE_AVAILABLE>' . "\n" .
            '<PRODUCTS_ORDERED>' . $products['products_ordered'] . '</PRODUCTS_ORDERED>' . "\n";

        ////////////////////////////
        // Beschreibung
        ////////////////////////////

        $detail_query = xtc_db_query("select
                                   products_id,
                                   language_id,
                                   products_name, " . TABLE_PRODUCTS_DESCRIPTION .
                ".products_description,
                                   products_short_description,
                                   products_meta_title,
                                   products_meta_description,
                                   products_meta_keywords,
                                   products_url,
                                   name as language_name, code as language_code " .
                "from " . TABLE_PRODUCTS_DESCRIPTION . ", " . TABLE_LANGUAGES . " " .
                "where " . TABLE_PRODUCTS_DESCRIPTION . ".language_id=" . TABLE_LANGUAGES . ".languages_id " .
                "and " . TABLE_PRODUCTS_DESCRIPTION . ".products_id=" . $products['products_id']);

        while ($details = xtc_db_fetch_array($detail_query)) {
            $schema .= "<PRODUCT_DESCRIPTION ID='" . $details["language_id"] . "' CODE='" . $details["language_code"] . "' NAME='" . $details["language_name"] . "'>\n";

            if ($details["products_name"] != 'Array') {
                $schema .= "<NAME>" . xtc_htmlspecialchars($details["products_name"]) . "</NAME>" . "\n";
            }
            $schema .= "<URL>" . xtc_htmlspecialchars($details["products_url"]) . "</URL>" . "\n";

            $prod_details = $details["products_description"];
            if ($prod_details != 'Array') {
                $schema .= "<DESCRIPTION>" . xtc_htmlspecialchars($details["products_description"]) . "</DESCRIPTION>" . "\n";
                $schema .= "<SHORT_DESCRIPTION>" . xtc_htmlspecialchars($details["products_short_description"]) . "</SHORT_DESCRIPTION>" . "\n";
                $schema .= "<META_TITLE>" . xtc_htmlspecialchars($details["products_meta_title"]) . "</META_TITLE>" . "\n";
                $schema .= "<META_DESCRIPTION>" . xtc_htmlspecialchars($details["products_meta_description"]) . "</META_DESCRIPTION>" . "\n";
                $schema .= "<META_KEYWORDS>" . xtc_htmlspecialchars($details["products_meta_keywords"]) . "</META_KEYWORDS>" . "\n";
            }
            $schema .= "</PRODUCT_DESCRIPTION>\n";
        }

        //////////////////////////////
        // Zusätzliche Bilder
        //////////////////////////////
        $schema .= "<ADDITIONAL_IMAGES>\n";

        $res = xtc_db_query("SELECT image_name FROM " . TABLE_PRODUCTS_IMAGES . " WHERE products_id = " . $products['products_id']);
        $iImgCnt = 1;
        while($row = xtc_db_fetch_array($res))
        {
            $schema .= "<ADDITIONAL_IMAGE>" . $row["image_name"] . "</ADDITIONAL_IMAGE>\n";
            
            //Maximal 11 Bilder ausgeben ( das erste ist in TABLE_PICTURES direkt )
            if($iImgCnt == 11)
                break;

            $iImgCnt++;
        }

        $schema .= "</ADDITIONAL_IMAGES>\n";

        $res = xtc_db_query("SELECT categories_id FROM " . TABLE_PRODUCTS_TO_CATEGORIES . " WHERE products_id='" . $products['products_id'] . "'");
        if($row = xtc_db_fetch_array($res))
            $categoryId = $row['categories_id'];
        $schema .= "<CATEGORY_ID>" . $categoryId . "</CATEGORY_ID>";
        
        // NEU JP 26.08.2005 Aktionspreise exportieren
        $special_query = "SELECT * from " . TABLE_SPECIALS . " " .
            "where products_id=" . $products['products_id'] . " limit 0,1";

        $special_result = xtc_db_query($special_query);

        while ($specials = xtc_db_fetch_array($special_result)) {
            $schema .= '<SPECIAL>' . "\n" .
                '<SPECIAL_PRICE>' . $specials['specials_new_products_price'] . '</SPECIAL_PRICE>' . "\n" .
                '<SPECIAL_DATE_ADDED>' . $specials['specials_date_added'] . '</SPECIAL_DATE_ADDED>' . "\n" .
                '<SPECIAL_LAST_MODIFIED>' . $specials['specials_last_modified'] . '</SPECIAL_LAST_MODIFIED>' . "\n" .
                '<SPECIAL_DATE_EXPIRES>' . $specials['expires_date'] . '</SPECIAL_DATE_EXPIRES>' . "\n" .
                '<SPECIAL_STATUS>' . $specials['status'] . '</SPECIAL_STATUS>' . "\n" .
                '<SPECIAL_DATE_STATUS_CHANGE>' . $specials['date_status_change'] . '</SPECIAL_DATE_STATUS_CHANGE>' . "\n" .
                '</SPECIAL>' . "\n";
        }
        // Ende Aktionspreise

        $schema .= '</PRODUCT_DATA>' . "\n" .
            '</PRODUCT_INFO>' . "\n";
        echo $schema;
    }
    $schema = '</PRODUCTS>' . "\n\n";
    echo $schema;
}

//--------------------------------------------------------------

function SendCustomers() {
    global $_GET;

    if (defined('SET_TIME_LIMIT')) {
        @set_time_limit(0);
    }

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<CUSTOMERS>' . "\n";
    echo $schema;

    $from = xtc_db_prepare_input($_GET['customers_from']);
    $anz = xtc_db_prepare_input($_GET['customers_count']);

    $address_query = "select
                    c.customers_gender, 
                    c.customers_id,
                    c.customers_cid, 
                    c.customers_dob, 
                    c.customers_email_address, 
                    c.customers_telephone, 
                    c.customers_fax,
                    c.customers_status,";

    //JAN Pruefen, ob mind. Version 3.x vom XTC und dann wenn das Feld existiert, dieses mit Abfragen
    $res = xtc_db_query('show fields from ' . TABLE_CUSTOMERS . ' like "customers_vat_id"');
    if (xtc_db_fetch_array($res)) {
        $address_query .= "c.customers_vat_id as vat_id,";
    }

    $address_query .= "ci.customers_info_date_account_created,
                    a.entry_firstname, 
                    a.entry_lastname, 
                    a.entry_company, 
                    a.entry_street_address, 
                    a.entry_city,
                    a.entry_postcode, 
                    a.entry_suburb,
                    a.entry_state,
                    co.countries_iso_code_2
                   from 
                    " . TABLE_CUSTOMERS . " c, 
                    " . TABLE_CUSTOMERS_INFO . " ci, 
                    " . TABLE_ADDRESS_BOOK . " a , 
                    " . TABLE_COUNTRIES . " co
                   where
                    c.customers_id = ci.customers_info_id AND
                    c.customers_id = a.customers_id AND
                    c.customers_default_address_id = a.address_book_id AND
                    a.entry_country_id  = co.countries_id";

    if (isset($from)) {
        if (!isset($anz))
            $anz = 1000;
        $address_query.= " limit " . $from . "," . $anz;
    }
    $address_result = xtc_db_query($address_query);

    while ($address = xtc_db_fetch_array($address_result)) {
        $schema = '<CUSTOMERS_DATA>' . "\n" .
            '<CUSTOMERS_ID>' . xtc_htmlspecialchars($address['customers_id']) . '</CUSTOMERS_ID>' . "\n" .
            '<CUSTOMERS_CID>' . xtc_htmlspecialchars($address['customers_cid']) . '</CUSTOMERS_CID>' . "\n" .
            '<GENDER>' . xtc_htmlspecialchars($address['customers_gender']) . '</GENDER>' . "\n" .
            '<COMPANY>' . xtc_htmlspecialchars($address['entry_company']) . '</COMPANY>' . "\n" .
            '<FIRSTNAME>' . xtc_htmlspecialchars($address['entry_firstname']) . '</FIRSTNAME>' . "\n" .
            '<LASTNAME>' . xtc_htmlspecialchars($address['entry_lastname']) . '</LASTNAME>' . "\n" .
            '<STREET>' . xtc_htmlspecialchars($address['entry_street_address']) . '</STREET>' . "\n" .
            '<POSTCODE>' . xtc_htmlspecialchars($address['entry_postcode']) . '</POSTCODE>' . "\n" .
            '<CITY>' . xtc_htmlspecialchars($address['entry_city']) . '</CITY>' . "\n" .
            '<SUBURB>' . xtc_htmlspecialchars($address['entry_suburb']) . '</SUBURB>' . "\n" .
            '<STATE>' . xtc_htmlspecialchars($address['entry_state']) . '</STATE>' . "\n" .
            '<COUNTRY>' . xtc_htmlspecialchars($address['countries_iso_code_2']) . '</COUNTRY>' . "\n" .
            '<TELEPHONE>' . xtc_htmlspecialchars($address['customers_telephone']) . '</TELEPHONE>' . "\n" . // JAN
            '<FAX>' . xtc_htmlspecialchars($address['customers_fax']) . '</FAX>' . "\n" . // JAN
            '<EMAIL>' . xtc_htmlspecialchars($address['customers_email_address']) . '</EMAIL>' . "\n" . // JAN
            '<BIRTHDAY>' . xtc_htmlspecialchars($address['customers_dob']) . '</BIRTHDAY>' . "\n" .
            '<VAT_ID>' . xtc_htmlspecialchars($address['vat_id']) . '</VAT_ID>' . "\n" .
            '<DATE_ACCOUNT_CREATED>' . xtc_htmlspecialchars($address['customers_info_date_account_created']) . '</DATE_ACCOUNT_CREATED>' . "\n";

        if (file_exists('cao_sendcust_1.php')) {
            include('cao_sendcust_1.php');
        }

        $schema .= '</CUSTOMERS_DATA>' . "\n";
        echo $schema;
    }
    $schema = '</CUSTOMERS>' . "\n\n";
    echo $schema;
}

//--------------------------------------------------------------

function SendCustomersNewsletter() {
    global $_GET;

    if (defined('SET_TIME_LIMIT')) {
        @set_time_limit(0);
    }

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<CUSTOMERS>' . "\n" .
        $from = xtc_db_prepare_input($_GET['customers_from']);
    $anz = xtc_db_prepare_input($_GET['customers_count']);

    $address_query = "select *
                    from " . TABLE_CUSTOMERS . "
                    where customers_newsletter = 1";

    if (isset($from)) {
        if (!isset($anz))
            $anz = 1000;
        $address_query.= " limit " . $from . "," . $anz;
    }
    $address_result = xtc_db_query($address_query);
    while ($address = xtc_db_fetch_array($address_result)) {
        $schema .= '<CUSTOMERS_DATA>' . "\n";
        $schema .= '<CUSTOMERS_ID>' . $address['customers_id'] . '</CUSTOMERS_ID>' . "\n";
        $schema .= '<CUSTOMERS_CID>' . $address['customers_cid'] . '</CUSTOMERS_CID>' . "\n";
        $schema .= '<CUSTOMERS_GENDER>' . $address['customers_gender'] . '</CUSTOMERS_GENDER>' . "\n";
        $schema .= '<CUSTOMERS_FIRSTNAME>' . $address['customers_firstname'] . '</CUSTOMERS_FIRSTNAME>' . "\n";
        $schema .= '<CUSTOMERS_LASTNAME>' . $address['customers_lastname'] . '</CUSTOMERS_LASTNAME>' . "\n";
        $schema .= '<CUSTOMERS_EMAIL_ADDRESS>' . $address['customers_email_address'] . '</CUSTOMERS_EMAIL_ADDRESS>' . "\n";
        $schema .= '</CUSTOMERS_DATA>' . "\n";
    }
    $schema .= '</CUSTOMERS>' . "\n\n";
    echo $schema;
}

//--------------------------------------------------------------

function SendShopConfig() {
    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
        '<CONFIG>' . "\n" .
        '<CONFIG_DATA>' . "\n";
    echo $schema;

    $config_sql = 'select * from configuration';
    $config_res = xtc_db_query($config_sql);

    while ($config = xtc_db_fetch_array($config_res)) {
        $schema = '<ENTRY ID="' . $config['configuration_id'] . '">' . "\n" .
            '<PARAM>' . xtc_htmlspecialchars($config['configuration_key']) . '</PARAM>' . "\n" .
            '<VALUE>' . xtc_htmlspecialchars($config['configuration_value']) . '</VALUE>' . "\n" .
            '<TITLE>' . xtc_htmlspecialchars($config['configuration_title']) . '</TITLE>' . "\n" .
            '<DESCRIPTION>' . xtc_htmlspecialchars($config['configuration_description']) . '</DESCRIPTION>' . "\n" .
            '<GROUP_ID>' . xtc_htmlspecialchars($config['config_group_id']) . '</GROUP_ID>' . "\n" .
            '<SORT_ORDER>' . xtc_htmlspecialchars($config['sort_order']) . '</SORT_ORDER>' . "\n" .
            '<USE_FUNCTION>' . xtc_htmlspecialchars($config['use_function']) . '</USE_FUNCTION>' . "\n" .
            '<SET_FUNCTION>' . xtc_htmlspecialchars($config['set_function']) . '</SET_FUNCTION>' . "\n" .
            '</ENTRY>' . "\n";
        echo $schema;
    }
    $schema = '</CONFIG_DATA>' . "\n";
    echo $schema;


    $schema = '<TAX_CLASS>' . "\n";
    echo $schema;

    $tax_class_sql = 'select * from tax_class';
    $tax_class_res = xtc_db_query($tax_class_sql);

    while ($tax_class = xtc_db_fetch_array($tax_class_res)) {
        $schema = '<CLASS ID="' . $tax_class['tax_class_id'] . '">' . "\n" .
            '<TITLE>' . xtc_htmlspecialchars($tax_class['tax_class_title']) . '</TITLE>' . "\n" .
            '<DESCRIPTION>' . xtc_htmlspecialchars($tax_class['tax_class_description']) . '</DESCRIPTION>' . "\n" .
            '<LAST_MODIFIED>' . xtc_htmlspecialchars($tax_class['last_modified']) . '</LAST_MODIFIED>' . "\n" .
            '<DATE_ADDED>' . xtc_htmlspecialchars($tax_class['date_added']) . '</DATE_ADDED>' . "\n" .
            '</CLASS>' . "\n";
        echo $schema;
    }

    $schema = '</TAX_CLASS>' . "\n";
    echo $schema;
    $schema = '<TAX_RATES>' . "\n";
    echo $schema;

    $tax_rates_sql = 'select * from tax_rates';
    $tax_rates_res = xtc_db_query($tax_rates_sql);

    while ($tax_rates = xtc_db_fetch_array($tax_rates_res)) {
        $schema = '<RATES ID="' . $tax_rates['tax_rates_id'] . '">' . "\n" .
            '<ZONE_ID>' . xtc_htmlspecialchars($tax_rates['tax_zone_id']) . '</ZONE_ID>' . "\n" .
            '<CLASS_ID>' . xtc_htmlspecialchars($tax_rates['tax_class_id']) . '</CLASS_ID>' . "\n" .
            '<PRIORITY>' . xtc_htmlspecialchars($tax_rates['tax_priority']) . '</PRIORITY>' . "\n" .
            '<RATE>' . xtc_htmlspecialchars($tax_rates['tax_rate']) . '</RATE>' . "\n" .
            '<DESCRIPTION>' . xtc_htmlspecialchars($tax_rates['tax_description']) . '</DESCRIPTION>' . "\n" .
            '<LAST_MODIFIED>' . xtc_htmlspecialchars($tax_rates['last_modified']) . '</LAST_MODIFIED>' . "\n" .
            '<DATE_ADDED>' . xtc_htmlspecialchars($tax_rates['date_added']) . '</DATE_ADDED>' . "\n" .
            '</RATES>' . "\n";
        echo $schema;
    }
    $schema = '</TAX_RATES>' . "\n";
    echo $schema;
    $schema = '</CONFIG>' . "\n";
    echo $schema;
}

//--------------------------------------------------------------

function SendXMLHeader() {
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");  // immer geändert
    header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
    header("Pragma: no-cache"); // HTTP/1.0
    header("Content-type: text/xml");
}

//--------------------------------------------------------------


function SendHTMLHeader() {
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");  // immer geändert
    header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
    header("Pragma: no-cache"); // HTTP/1.0
    header("Content-type: text/html");
}

//--------------------------------------------------------------

function ShowHTMLMenu() {
    global $version_nr, $version_datum, $user, $password, $PHP_SELF;

    SendHTMLHeader;

    $Url = $PHP_SELF . "?user=" . $user . "&password=" . $password;
?>
    <html><head></head><body>
            <h3>xt:Commerce Shopanbindung</h3>
            <h4>Version <?php echo $version_nr; ?> Stand : <?php echo $version_datum; ?></h4>
            <br>
            <br><b>m&ouml;gliche Funktionen :</b><br><br>
            <a href="<?php echo $Url; ?>&action=version">Ausgabe XML Scriptversion</a><br>
            <br>
            <a href="<?php echo $Url; ?>&action=manufacturers_export">Ausgabe XML Manufacturers</a><br>
            <a href="<?php echo $Url; ?>&action=categories_export">Ausgabe XML Categories</a><br>
            <a href="<?php echo $Url; ?>&action=products_export">Ausgabe XML Products</a><br>
            <a href="<?php echo $Url; ?>&action=customers_export">Ausgabe XML Customers</a><br>
            <a href="<?php echo $Url; ?>&action=customers_newsletter_export">Ausgabe XML Customers-Newsletter</a><br>
            <br>
            <a href="<?php echo $Url; ?>&action=orders_export">Ausgabe XML Orders</a><br>
            <br>
            <a href="<?php echo $Url; ?>&action=config_export">Ausgabe XML Shop-Config</a><br>
            <br>
<?php
    //Geändert am 18.01.2011 von CM: Haftunsausschluss
    echo "<br><b>Achtung: Die Verwendung der Skripte erfolgt auf eigene Gefahr. Es wird keinerlei Garantie übernommen. Beachten Sie die beigefügten Lizenztexte.</b>";
?>
        </body>
    </html>
<?php
}

//--------------------------------------------------------------

function xtc_try_upload($file = '', $destination = '', $permissions = '777', $extensions = '') {
    $file_object = new upload($file, $destination, $permissions, $extensions);
    if ($file_object->filename != '')
        return $file_object; else
        return false;
}

// Hinzugefügt am 13.11.2013 von CM: Ab PHP 5.4 ist der default charset bei htmlspecialchars UTF-8
function xtc_htmlspecialchars($value)
{
    return htmlspecialchars($value, ENT_COMPAT | ENT_HTML401, "UTF-8");
}

function xtc_clear_cache_after_products_modifed($productId)
{
    if(class_exists("CacheControl", false))
    {
        $CacheCtrl = new CacheControl();
        $CacheCtrl->rebuild_products_properties_index(array($productId));
        $CacheCtrl->rebuild_products_feature_index(array($productId));
    }
}

function xtc_clear_cache_after_categories_modified($productId)
{
    if(class_exists("CacheControl", false))
    {
        $CacheCtrl = new CacheControl();
        $CacheCtrl->rebuild_products_categories_index(array($productId));
        $CacheCtrl->rebuild_categories_submenus_cache();
    }
}


//--------------------------------------------------------------

require_once(DIR_FS_INC . 'xtc_not_null.inc.php');

function clear_string($value) {
    $string = str_replace("'", '', $value);
    $string = str_replace(')', '', $string);
    $string = str_replace('(', '', $string);
    $array = explode(',', $string);
    return $array;
}

//--------------------------------------------------------------

function xtc_RandomString($length) {
    $chars = array('a', 'A', 'b', 'B', 'c', 'C', 'd', 'D', 'e', 'E', 'f', 'F', 'g', 'G', 'h', 'H', 'i', 'I', 'j', 'J', 'k', 'K', 'l', 'L', 'm', 'M', 'n', 'N', 'o', 'O', 'p', 'P', 'q', 'Q', 'r', 'R', 's', 'S', 't', 'T', 'u', 'U', 'v', 'V', 'w', 'W', 'x', 'X', 'y', 'Y', 'z', 'Z', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0');

    $max_chars = count($chars) - 1;
    srand((double) microtime() * 1000000);

    $rand_str = '';
    for ($i = 0; $i < $length; $i++) {
        $rand_str = ( $i == 0 ) ? $chars[rand(0, $max_chars)] : $rand_str . $chars[rand(0, $max_chars)];
    }

    return $rand_str;
}

//--------------------------------------------------------------

function xtc_create_password($pass) {
    return md5($pass);
}

//--------------------------------------------------------------

function xtc_remove_product($product_id) {
    global $DefaultLangID, $customers_status_array;  //R Brym
    $product_image_query = xtc_db_query("select products_image from " . TABLE_PRODUCTS . " where products_id = '" . xtc_db_input($product_id) . "'");
    $product_image = xtc_db_fetch_array($product_image_query);

    $duplicate_image_query = xtc_db_query("select count(*) as total from " . TABLE_PRODUCTS . " where products_image = '" . xtc_db_input($product_image['products_image']) . "'");
    $duplicate_image = xtc_db_fetch_array($duplicate_image_query);

    if ($duplicate_image['total'] < 2) {
        if (file_exists(DIR_FS_CATALOG_POPUP_IMAGES . $product_image['products_image'])) {
            @unlink(DIR_FS_CATALOG_POPUP_IMAGES . $product_image['products_image']);
        }
        // START CHANGES
        $image_subdir = BIG_IMAGE_SUBDIR;
        if (substr($image_subdir, -1) != '/')
            $image_subdir .= '/';
        if (file_exists(DIR_FS_CATALOG_IMAGES . $image_subdir . $product_image['products_image'])) {
            @unlink(DIR_FS_CATALOG_IMAGES . $image_subdir . $product_image['products_image']);
        }
        // END CHANGES
    }

    xtc_db_query("delete from " . TABLE_SPECIALS . " where products_id = '" . xtc_db_input($product_id) . "'");
    xtc_db_query("delete from " . TABLE_PRODUCTS . " where products_id = '" . xtc_db_input($product_id) . "'");
    xtc_db_query("delete from " . TABLE_PRODUCTS_TO_CATEGORIES . " where products_id = '" . xtc_db_input($product_id) . "'");
    xtc_db_query("delete from " . TABLE_PRODUCTS_DESCRIPTION . " where products_id = '" . xtc_db_input($product_id) . "'");
    xtc_db_query("delete from " . TABLE_PRODUCTS_ATTRIBUTES . " where products_id = '" . xtc_db_input($product_id) . "'");
    xtc_db_query("delete from " . TABLE_CUSTOMERS_BASKET . " where products_id = '" . xtc_db_input($product_id) . "'");
    xtc_db_query("delete from " . TABLE_CUSTOMERS_BASKET_ATTRIBUTES . " where products_id = '" . xtc_db_input($product_id) . "'");

    if (defined('TABLE_PRODUCTS_IMAGES')) {
        xtc_db_query("delete from " . TABLE_PRODUCTS_IMAGES . " where products_id = '" . xtc_db_input($product_id) . "'");
    }


    // get statuses
    $customers_statuses_array = array(array());

    $customers_statuses_query = xtc_db_query("select * from " . TABLE_CUSTOMERS_STATUS . " where language_id = '" . $DefaultLangID . "' order by customers_status_id");

    while ($customers_statuses = xtc_db_fetch_array($customers_statuses_query)) {
        $customers_statuses_array[] = array('id' => $customers_statuses['customers_status_id'],
            'text' => $customers_statuses['customers_status_name']);
    }

    for ($i = 0, $n = sizeof($customers_status_array); $i < $n; $i++) {
        xtc_db_query("delete from personal_offers_by_customers_status_" . $i . " where products_id = '" . xtc_db_input($product_id) . "'");
    }

    $product_reviews_query = xtc_db_query("select reviews_id from " . TABLE_REVIEWS . " where products_id = '" . xtc_db_input($product_id) . "'");
    while ($product_reviews = xtc_db_fetch_array($product_reviews_query)) {
        xtc_db_query("delete from " . TABLE_REVIEWS_DESCRIPTION . " where reviews_id = '" . $product_reviews['reviews_id'] . "'");
    }
    xtc_db_query("delete from " . TABLE_REVIEWS . " where products_id = '" . xtc_db_input($product_id) . "'");
}

//--------------------------------------------------------------

function ManufacturersImageUpload() {
    global $_GET, $_POST;

    if ($manufacturers_image = &xtc_try_upload('manufacturers_image', DIR_FS_CATALOG . DIR_WS_IMAGES, '777', '', true)) {
        $code = 0;
        $message = 'OK';
    } else {
        $code = -1;
        $message = 'UPLOAD FAILED';
    }
    print_xml_status($code, $_POST['action'], $message, '', 'FILE_NAME', $manufacturers_image->filename);
}

//--------------------------------------------------------------

function CategoriesImageUpload() {
    global $_GET, $_POST;
    if ($categories_image = &xtc_try_upload('categories_image', DIR_FS_CATALOG . DIR_WS_IMAGES . 'categories/', '777', '', true)) {
        $code = 0;
        $message = 'OK';
    } else {
        $code = -1;
        $message = 'UPLOAD FAILED';
    }
    print_xml_status($code, $_POST['action'], $message, '', 'FILE_NAME', $categories_image->filename);
}

//--------------------------------------------------------------

function ProductsImageUpload() {
    global $_GET, $_POST;
    if ($products_image = xtc_try_upload('products_image', DIR_FS_CATALOG . DIR_WS_ORIGINAL_IMAGES, '777', '', true)) {
        $products_image_name = $products_image->filename;
        // rewrite values to use resample classes
        define('DIR_FS_CATALOG_ORIGINAL_IMAGES', DIR_FS_CATALOG . DIR_WS_ORIGINAL_IMAGES);
        define('DIR_FS_CATALOG_INFO_IMAGES', DIR_FS_CATALOG . DIR_WS_INFO_IMAGES);
        define('DIR_FS_CATALOG_POPUP_IMAGES', DIR_FS_CATALOG . DIR_WS_POPUP_IMAGES);
        define('DIR_FS_CATALOG_THUMBNAIL_IMAGES', DIR_FS_CATALOG . DIR_WS_THUMBNAIL_IMAGES);
        define('DIR_FS_CATALOG_IMAGES', DIR_FS_CATALOG . DIR_WS_IMAGES);
        
        // Hinzugefügt am 08.02.2012 von CM: sell-it-smart.de Gallery-Bilder (MiniThumbnails für XTC)
        define('DIR_FS_CATALOG_MINI_IMAGES', DIR_FS_CATALOG_IMAGES .'product_images/mini_images/');

        // generate resampled images
        require(DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_thumbnail_images.php');
        require(DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_info_images.php');
        require(DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_popup_images.php');

        // Geändert am 15.07.2011 von CM:
        // BUGFIX 2011-07-15: GambioGx2 wurden die Gallery-Bilder nicht angezeigt
        $ProductGalleryImagesPath = DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_gallery_images.php';
        if(file_exists($ProductGalleryImagesPath))
            require($ProductGalleryImagesPath);
        
        // Hinzugefügt am 08.02.2012 von CM: sell-it-smart.de Gallery-Bilder (MiniThumbnails für XTC)
        $ProductGalleryImagesPath = DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_mini_images.php';
        if(file_exists($ProductGalleryImagesPath))
            require($ProductGalleryImagesPath);

        $code = 0;
        $message = 'OK';
    } else {
        $code = -1;
        $message = 'UPLOAD FAILED';
    }
    print_xml_status($code, $_POST['action'], $message, '', 'FILE_NAME', $products_image->filename);
}

//--------------------------------------------------------------

function ProductsImageUploadMed() {
    ProductsImageUpload ();
}

//--------------------------------------------------------------

function ProductsImageUploadLarge() {
    ProductsImageUpload ();
}

//--------------------------------------------------------------

function CheckImages($FileName) {
    $products_image_name = $FileName;

    // rewrite values to use resample classes
    define('DIR_FS_CATALOG_ORIGINAL_IMAGES', DIR_FS_CATALOG . DIR_WS_ORIGINAL_IMAGES);
    define('DIR_FS_CATALOG_INFO_IMAGES', DIR_FS_CATALOG . DIR_WS_INFO_IMAGES);
    define('DIR_FS_CATALOG_POPUP_IMAGES', DIR_FS_CATALOG . DIR_WS_POPUP_IMAGES);
    define('DIR_FS_CATALOG_THUMBNAIL_IMAGES', DIR_FS_CATALOG . DIR_WS_THUMBNAIL_IMAGES);
    define('DIR_FS_CATALOG_IMAGES', DIR_FS_CATALOG . DIR_WS_IMAGES);

    // generate resampled images
    if (file_exists(DIR_FS_CATALOG_ORIGINAL_IMAGES . $FileName)) {

        if (!file_exists(DIR_FS_CATALOG_INFO_IMAGES . $FileName)) {
            require(DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_info_images.php');
        }

        if (!file_exists(DIR_FS_CATALOG_THUMBNAIL_IMAGES . $FileName)) {
            require(DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_thumbnail_images.php');
        }

        if (!file_exists(DIR_FS_CATALOG_POPUP_IMAGES . $FileName)) {
            require(DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_popup_images.php');
        }

        if (!file_exists(DIR_FS_CATALOG_IMAGES . 'product_images/gallery_images/' . $FileName) && file_exists(DIR_FS_CATALOG_IMAGES . 'admin/includes/product_gallery_images.php'))
            require(DIR_FS_DOCUMENT_ROOT . 'admin/includes/product_gallery_images.php');
    }
}

//--------------------------------------------------------------

function ManufacturersUpdate() {
    global $_POST;

    $manufacturers_id = xtc_db_prepare_input($_POST['mID']);

    if (isset($manufacturers_id)) {
        // Hersteller laden
        $count_query = xtc_db_query("select
                                  manufacturers_id,
	                               manufacturers_name,
	                               manufacturers_image,
	                               date_added,
	                               last_modified from " . TABLE_MANUFACTURERS . "
	                               where manufacturers_id='" . $manufacturers_id . "'");

        if ($manufacturer = xtc_db_fetch_array($count_query)) {
            $exists = 1;
            // aktuelle Herstellerdaten laden
            $manufacturers_name = $manufacturer['manufacturers_name'];
            $manufacturers_image = $manufacturer['manufacturers_image'];
            $date_added = $manufacturer['date_added'];
            $last_modified = $manufacturer['last_modified'];
        }
        else
            $exists = 0;

        // Variablen nur ueberschreiben wenn als Parameter vorhanden !!!
        if (isset($_POST['manufacturers_name']))
            $manufacturers_name = xtc_db_prepare_input($_POST['manufacturers_name']);
        if (isset($_POST['manufacturers_image']))
            $manufacturers_image = xtc_db_prepare_input($_POST['manufacturers_image']);

        $sql_data_array = array('manufacturers_id' => $manufacturers_id,
            'manufacturers_name' => $manufacturers_name,
            'manufacturers_image' => $manufacturers_image);

        if ($exists == 0) { // Neuanlage (ID wird von CAO virgegeben !!!)
            $mode = 'APPEND';
            $insert_sql_data = array('date_added' => 'now()');
            $sql_data_array = array_merge($sql_data_array, $insert_sql_data);

            xtc_db_perform(TABLE_MANUFACTURERS, $sql_data_array);
            $products_id = xtc_db_insert_id();
        } elseif ($exists == 1) { //Update
            $mode = 'UPDATE';
            $update_sql_data = array('last_modified' => 'now()');
            $sql_data_array = array_merge($sql_data_array, $update_sql_data);

            xtc_db_perform(TABLE_MANUFACTURERS, $sql_data_array, 'update', 'manufacturers_id = \'' . xtc_db_input($manufacturers_id) . '\'');
        }
        $languages_query = xtc_db_query("select languages_id, name, code, image, directory from " . TABLE_LANGUAGES . " order by sort_order");
        while ($languages = xtc_db_fetch_array($languages_query)) {
            $languages_array[] = array('id' => $languages['languages_id'],
                'name' => $languages['name'],
                'code' => $languages['code'],
                'image' => $languages['image'],
                'directory' => $languages['directory']);
        }
        $languages = $languages_array;
        for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
            $language_id = $languages[$i]['id'];

            // Bestehende Daten laden
            $desc_query = xtc_db_query("select manufacturers_id,languages_id,manufacturers_url,url_clicked,date_last_click from " .
                    TABLE_MANUFACTURERS_INFO . " where manufacturers_id='" . $manufacturers_id . "' and languages_id='" . $language_id . "'");
            if ($desc = xtc_db_fetch_array($desc_query)) {
                $manufacturers_url = $desc['manufacturers_url'];
                $url_clicked = $desc['url_clicked'];
                $date_last_click = $desc['date_last_click'];
            }

            // uebergebene Daten einsetzen
            if (isset($_POST['manufacturers_url'][$language_id]))
                $manufacturers_url = xtc_db_prepare_input($_POST['manufacturers_url'][$language_id]);
            if (isset($_POST['url_clicked'][$language_id]))
                $url_clicked = xtc_db_prepare_input($_POST['url_clicked'][$language_id]);
            if (isset($_POST['date_last_click'][$language_id]))
                $date_last_click = xtc_db_prepare_input($_POST['date_last_click'][$language_id]);

            $sql_data_array = array('manufacturers_url' => $manufacturers_url);

            if ($exists == 0) { // Insert
                $insert_sql_data = array('manufacturers_id' => $products_id,
                    'languages_id' => $language_id);
                $sql_data_array = /* xtc_ */array_merge($sql_data_array, $insert_sql_data);
                xtc_db_perform(TABLE_MANUFACTURERS_INFO, $sql_data_array);
            } elseif ($exists == 1) { // Update
                xtc_db_perform(TABLE_MANUFACTURERS_INFO, $sql_data_array, 'update', 'manufacturers_id = \'' . xtc_db_input($manufacturers_id) . '\' and languages_id = \'' . $language_id . '\'');
            }
        }
        print_xml_status(0, $_POST['action'], 'OK', $mode, 'MANUFACTURERS_ID', $mID);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function ManufacturersErase() {
    global $_POST;

    $ManID = xtc_db_prepare_input($_POST['mID']);

    if (isset($ManID)) {
        // Hersteller loeschen
        xtc_db_query("delete from " . TABLE_MANUFACTURERS . " where manufacturers_id = '" . (int) $ManID . "'");
        xtc_db_query("delete from " . TABLE_MANUFACTURERS_INFO . " where manufacturers_id = '" . (int) $ManID . "'");
        // Herstellerverweis in den Artikeln loeschen
        xtc_db_query("update " . TABLE_PRODUCTS . " set manufacturers_id = '' where manufacturers_id = '" . (int) $ManID . "'");

        print_xml_status(0, $_POST['action'], 'OK', '', '', '');
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function ProductsUpdate() {
    ///////////////////////////////////////////////////
    // Varianten-Verwaltung
    // Artikel, die einen Master-Model haben, also eine Variante sind nicht als Artikel anlegen, sondern als Attribut
    ///////////////////////////////////////////////////

    // Geändert am 28.07.2011 von CM: beim Setzten auf inaktiv wird product_update mit is_variation auferufen
    if(empty($_POST["products_master_model"]) && (empty($_POST["is_variation"]) || $_POST["is_variation"] != "1"))
        ProductsUpdateProduct();
    else
        ProductsUpdateVariation();
}

function ProductsUpdateVariation() {
    global $DefaultLangID;

    if(isset($_POST["products_status"]) && $_POST["products_status"] == 0)
    {
        //Wenn die Variante noch nie angelegt wurde, ist hier nichts zu tun
        if(empty($_POST["pID"]))
        {
            print_xml_status(0, $_POST['action'], 'OK', "UPDATE", 'PRODUCTS_ID', $pID);
            return;
        }

        //Wenn eine Variante auf inaktiv gesetzt wird muss diese gelöscht werden, damit sie nicht mehr angezeigt wird
        $pID = xtc_db_prepare_input($_POST["pID"]);
        xtc_db_query("DELETE FROM " . TABLE_PRODUCTS_ATTRIBUTES . " WHERE products_attributes_id = " . xtc_db_input($pID));
        // Geändert am 03.02.2014 von CM: Wenn die Variante nicht mehr existiert, ist die Arbeit bereits erledigt
        print_xml_status(0, $_POST['action'], 'OK', "UPDATE", 'PRODUCTS_ID', $pID);
        
        return;
    }
    
    if(!empty($_POST["products_master_model"]))
    {
        $products_master_model = xtc_db_prepare_input($_POST["products_master_model"]);
        $res = xtc_db_query("SELECT products_id, products_price, products_weight FROM " . TABLE_PRODUCTS . " WHERE products_model = '" . xtc_db_input($products_master_model) . "'");

        // Geändert am 25.10.2011 von CM: Artikel überspringen, wenn die Lagerhaltungsnummer von Hauptartikel doppelt vorhanden
        if(xtc_db_num_rows($res) > 1)
        {
            print_xml_status(-1,$_POST["action"], "Es sind mehrere Hauptartikel mit der Lagerhaltungsnummer '" . $_POST["products_master_model"] . "' vorhanden.");
            return;
        }
        
        if(!$parent_data = xtc_db_fetch_array($res))
        {
            print_xml_status(-1, $_POST["action"], "Der zugehörige Hauptartikel existiert nicht.");
            return;
        }
    }

    ////////////////////////////////
    // Product_Options prüfen und ggf erstellen ( z.B. "Größe, Farbe" )
    ////////////////////////////////

    $attributes = array();

    for($i=0;$i<count($_POST["products_attributes_keys"]);$i++)
    {
        $key = trim($_POST["products_attributes_keys"][$i]);
        $value = trim($_POST["products_attributes_values"][$i]);
        if(!empty($key) && !empty($value))
        {
            // Geändert am 15.02.2012 von CM: Eingaben excapen
            $key = xtc_db_prepare_input($key);
            $value = xtc_db_prepare_input($value);
            
            $attributes[$key] = $value;
        }
    }

    if(count($attributes) > 0)
    {
        //Da hier die Reihenfolge der Keys eine wichtige Rolle spielt aphabetisch nach dem key sortieren
        ksort($attributes,SORT_STRING);

        //Durch die etwas andere Handhabung der Varianten in Gambio, muss - damit jede Variante eine eindeutige Lagerhaltungsnummer, Bestand und Preis haben
        //Als ein Attribut angelegt werden -> Auction Studio liegt für einen Varianten Artikel ein Attribut an, welches dann in der GUI richtig interpretiert werden muss
        // z.B. Attributen-Name :"Größe, Farbe" und Attributen-Wert: "X, rot". Das Template muss dan so angepasst werden, dass diese Werte unabhängig voneinander ausgewählt werden können

        $variation_name = join(", ", array_keys($attributes));
        $variation_data = join(", ", array_values($attributes));
        
        // Geändert am 22.05.2012 von CM: Länge von name und data prüfen
        // SQL zum erweitern:
        // ALTER TABLE products_options MODIFY products_options_name VARCHAR(255);
        // ALTER TABLE products_options_values MODIFY products_options_values_name VARCHAR(255);
        // ALTER TABLE orders_products_attributes MODIFY products_options_values VARCHAR(255);
        // ALTER TABLE orders_products_attributes MODIFY products_options VARCHAR(255);
        if(strlen($variation_name) > get_column_max_length(TABLE_PRODUCTS_OPTIONS, "products_options_name"))
        {
            print_xml_status(-1,$_POST["action"], "Die Bezeichnungen der Variantenkombinationen des Artikels '" . $_POST["products_master_model"] . "' sind zu lang. Kürzen Sie die Variantenbezeichnungen oder erweitern Sie das Datenbank Feld TABLE_PRODUCTS_OPTIONS.products_options_name in Ihrer Shop-Datenbank.");
            return;
        }
        
        if(strlen($variation_data) > get_column_max_length(TABLE_PRODUCTS_OPTIONS_VALUES, "products_options_values_name"))
        {
            print_xml_status(-1,$_POST["action"], "Die Werte der Variantenkombinationen des Artikels '" . $_POST["products_master_model"] . "' sind zu lang. Kürzen Sie die Variantenbezeichnungen oder erweitern Sie das Datenbank Feld TABLE_PRODUCTS_OPTIONS_VALUES.products_options_values_name in Ihrer Shop-Datenbank.");
            return;
        }    

        //Product-Options suchen ggf anlegen
        $res = xtc_db_query("SELECT products_options_id FROM " . TABLE_PRODUCTS_OPTIONS . " WHERE BINARY products_options_name = '" . xtc_db_input($variation_name) . "'");
        if($row = xtc_db_fetch_array($res))
            $products_options_id = $row["products_options_id"];
        else
        {
            $products_options_id = GetNextIdFromTableWithoutAutoIncrement(TABLE_PRODUCTS_OPTIONS,"products_options_id");
            xtc_db_query("INSERT INTO " . TABLE_PRODUCTS_OPTIONS . " (products_options_id,language_id,products_options_name) VALUES (" . xtc_db_input($products_options_id) . "," . xtc_db_input($DefaultLangID) . ",'" . xtc_db_input($variation_name) . "')");
        }

        //Product-Values suchen ggf anlegen
        $res = xtc_db_query("SELECT products_options_values_id FROM " . TABLE_PRODUCTS_OPTIONS_VALUES . " WHERE BINARY products_options_values_name = '" . xtc_db_input($variation_data) . "'");
        if($row = xtc_db_fetch_array($res))
            $products_options_values_id = $row["products_options_values_id"];
        else
        {
            $products_options_values_id = GetNextIdFromTableWithoutAutoIncrement(TABLE_PRODUCTS_OPTIONS_VALUES, "products_options_values_id");
            xtc_db_query("INSERT INTO " . TABLE_PRODUCTS_OPTIONS_VALUES . " (products_options_values_id,language_id,products_options_values_name) VALUES (" . xtc_db_input($products_options_values_id) . "," . xtc_db_input($DefaultLangID) . ",'" . xtc_db_input($variation_data) . "')");
        }

        //Verbindung zwischen Product-Options und Product-Values ggf anlegen
        $res = xtc_db_query("SELECT COUNT(*) AS Count FROM " . TABLE_PRODUCTS_OPTIONS_VALUES_TO_PRODUCTS_OPTIONS . " WHERE products_options_id = " . xtc_db_input($products_options_id) . " AND products_options_values_id = " . xtc_db_input($products_options_values_id));
        if($row = xtc_db_fetch_array($res))
        {
            if($row["Count"] <= 0)
                xtc_db_query("INSERT INTO " . TABLE_PRODUCTS_OPTIONS_VALUES_TO_PRODUCTS_OPTIONS . " (products_options_id, products_options_values_id) VALUES (" . xtc_db_input($products_options_id) . "," . xtc_db_input($products_options_values_id) . ")");
        }
    }

    //Zuordnung zu dem Parent-Artikel
    if(!empty($products_options_id)) $data["options_id"] = $products_options_id;
    if(!empty($products_options_values_id)) $data["options_values_id"] = $products_options_values_id;
    if(isset($_POST["products_model"])) $data["attributes_model"] = xtc_db_prepare_input($_POST["products_model"]);
    if(!empty($parent_data["products_id"])) $data["products_id"] = $parent_data["products_id"];
    
    if(isset($_POST["products_quantity"])) $data["attributes_stock"] = xtc_db_prepare_input($_POST["products_quantity"]);
    if(isset($_POST["products_sort"])) $data["sortorder"] = xtc_db_prepare_input($_POST["products_sort"]);
    if(isset($_POST["products_ean"]) && column_exists("products_attributes","gm_ean")) $data["gm_ean"] = xtc_db_prepare_input($_POST["products_ean"]);
    
    if(isset($_POST["products_price"]))
    {
        $price = floatval($_POST["products_price"]);
        
        //Der Preis der Variante wird in Abhängigkeit des Parent-Artikels angegeben
        if($parent_data["products_price"] < $price)
        {
            $data["price_prefix"] = "+";
            $data["options_values_price"] = $price - $parent_data["products_price"];
        }else
        {
            $data["price_prefix"] = "-";
            $data["options_values_price"] = $parent_data["products_price"] - $price;
        }
    }

    if(isset($_POST["products_weight"]))
    {
        $weight = floatval($_POST["products_weight"]);
        //Auch das Gewicht der Variante wird in Abhängigkeit des Parent-Artikels angegeben
        // Geändert am 15.12.2011 von CM: Gewicht richtig eintragen
        if($parent_data["products_weight"] < $weight)
        {
            $data["weight_prefix"] = "+";
            $data["options_values_weight"] = $weight - $parent_data["products_weight"];
        }else
        {
            $data["weight_prefix"] = "-";
            $data["options_values_weight"] = $parent_data["products_weight"] - $weight;
        }
    }

    //TODO: VPE für Varianten unterstützen

    $mode = "APPEND";
    if(!empty($_POST["pID"]))
    {
        $pID = intval($_POST["pID"]);
        $res = xtc_db_query("SELECT products_attributes_id FROM " . TABLE_PRODUCTS_ATTRIBUTES
                      . " WHERE products_attributes_id = '" . $pID . "'");
        
        if($row = xtc_db_fetch_array($res))
        {
            $products_attribute_id = $row["products_attributes_id"];
            $mode = "UPDATE";
        }

    }
    
    if($mode == "UPDATE")
    {
        //Bereits bestehende Variante aktualisieren
        xtc_db_perform(TABLE_PRODUCTS_ATTRIBUTES, $data, "update", "products_attributes_id = " . xtc_db_input($products_attribute_id));
    }else
    {
        if(empty($data["options_id"]) || empty($data["options_values_id"]) || empty($data["products_id"]))
        {
            print_xml_status(-1, $_POST["action"], "Es wurden nicht alle benötigten Informationen zum erstellen einer Variante übergeben");
            return;
        }
        
        //Neue Variante einfügen
        xtc_db_perform(TABLE_PRODUCTS_ATTRIBUTES, $data);
        $products_attribute_id = xtc_db_insert_id();
    }

    //Als Product_ID zurück geben, da für Auction Studio jede Variante ein eigener Stammartikel ist
    print_xml_status(0, $_POST['action'], 'OK', $mode, 'PRODUCTS_ID', $products_attribute_id);
}

function ProductsUpdateProduct() {
    global $_POST, $DefaultLangID;        
    
    $languages_query = xtc_db_query("select languages_id, name, code, image, directory from " . TABLE_LANGUAGES . " order by sort_order");
    while ($languages = xtc_db_fetch_array($languages_query)) {
        $languages_array[] = array('id' => $languages['languages_id'],
            'name' => $languages['name'],
            'code' => $languages['code'],
            'image' => $languages['image'],
            'directory' => $languages['directory']);
    }

    $products_id = intval($_POST['pID']);


    //VPE JP20060130
    if ((defined('TABLE_PRODUCTS_VPE')) and (USE_VPE == true)) {
        if (!empty($_POST['products_me'])) {
            $vpe_name = xtc_db_prepare_input($_POST['products_me']);

            $vpe_query = xtc_db_query("select products_vpe_id from " . TABLE_PRODUCTS_VPE .
                    " where products_vpe_name='" . $vpe_name . "' and " .
                    "language_id='" . $DefaultLangID . "'");
            if ($vpe_res = xtc_db_fetch_array($vpe_query)) {
                //VPE existiert bereits
                $products_vpe_id = $vpe_res['products_vpe_id'];
            } else {
                //VPE neu anlegen
                $next_id_query = xtc_db_query("select max(products_vpe_id) as products_vpe_id from " . TABLE_PRODUCTS_VPE . "");
                $next_id = xtc_db_fetch_array($next_id_query);
                $products_vpe_id = $next_id['products_vpe_id'] + 1;


                $languages = $languages_array;
                for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
                    $language_id = $languages[$i]['id'];

                    $insert_sql_data = array('products_vpe_id' => $products_vpe_id,
                        'language_id' => $language_id,
                        'products_vpe_name' => $vpe_name);

                    xtc_db_perform(TABLE_PRODUCTS_VPE, $insert_sql_data);
                }
            }
        }
    }



    // product laden
    $sql = "select products_quantity,
	              products_model,
	              products_image,
	              products_price,
	              products_date_available,
	              products_weight,
	              products_status,
	              products_ean,
	              products_fsk18,
	              products_shippingtime,
	              products_tax_class_id,
	              manufacturers_id";

    if ((defined('TABLE_PRODUCTS_VPE')) and (USE_VPE == true)) {
        $sql .= ",products_vpe_value"
            // Geändert am 25.10.2010 von CM: products_vpe mit laden (products_vpe_id ( also VPE-Einheit ) nicht ändern, wenn sie nicht übergeben wurde)
            . ",products_vpe";
    }

    // Geändert am 24.12.2010 von CM: Sortierreihenfolger über Connector veränderbar
    $sql .= ",products_startpage,products_sort,products_startpage_sort";
    $sql .= " from " . TABLE_PRODUCTS . " where products_id='" . $products_id . "'";


    $count_query = xtc_db_query($sql);

    if ($product = xtc_db_fetch_array($count_query)) {
        $exists = 1;
        // aktuelle Produktdaten laden
        $products_quantity = $product['products_quantity'];
        $products_model = $product['products_model'];
        $products_image = $product['products_image'];
        $products_price = $product['products_price'];
        $products_date_available = $product['products_date_available'];
        $products_weight = $product['products_weight'];
        $products_status = $product['products_status'];
        $products_ean = $product['products_ean'];
        $products_fsk18 = $product['products_fsk18'];
        $products_shippingtime = $product['products_shippingtime'];
        $products_tax_class_id = $product['products_tax_class_id'];
        $manufacturers_id = $product['manufacturers_id'];
        $products_vpe_value = $product['products_vpe_value'];
        // Geändert am 24.12.2010 von CM: Sortierreihenfolge über Connector veränderbar
        $products_sort = $product['products_sort'];
        $products_startpage_sort = $product['products_startpage_sort'];
        // Geändert am 19.01.2012 von CM: 
        $products_startpage = $product['products_startpage'];

        // Geändert am 25.10.2010 von CM: products_vpe_id ( also VPE-Einheit ) nicht ändern, wenn sie nicht übergeben wurde
        if (empty($_POST['products_me']))
            $products_vpe_id = $product['products_vpe'];
    }
    else
        $exists = 0;

    // Variablen nur ueberschreiben wenn als Parameter vorhanden !!!
    if (isset($_POST['products_quantity']))
        $products_quantity = xtc_db_prepare_input($_POST['products_quantity']);
    if (isset($_POST['products_model']))
        $products_model = xtc_db_prepare_input($_POST['products_model']);
    if (isset($_POST['products_image'])) {
        $products_image = xtc_db_prepare_input($_POST['products_image']);
        CheckImages($products_image);
    }
    if (isset($_POST['products_price']))
        $products_price = xtc_db_prepare_input($_POST['products_price']);
    if (isset($_POST['products_date_available']))
        $products_date_available = xtc_db_prepare_input($_POST['products_date_available']);
    if (isset($_POST['products_weight']))
        $products_weight = xtc_db_prepare_input($_POST['products_weight']);
    if (isset($_POST['products_status']))
        $products_status = xtc_db_prepare_input($_POST['products_status']);
    if (isset($_POST['products_ean']))
        $products_ean = xtc_db_prepare_input($_POST['products_ean']);
    // Geändert am 04.12.2013 von CM: 
    //if (isset($_POST['products_fsk18']))
    //    $products_fsk18 = xtc_db_prepare_input($_POST['products_fsk18']);
    if(isset($_POST['products_fskage']))
        $products_fsk18 = intval($_POST['products_fskage']) >= 18 ? '1' : '0';
    
    if (isset($_POST['products_shippingtime']))
        $products_shippingtime = xtc_db_prepare_input($_POST['products_shippingtime']);
    if (isset($_POST['products_tax_class_id']))
        $products_tax_class_id = xtc_db_prepare_input($_POST['products_tax_class_id']);
    if (isset($_POST['products_vpe']))
        $products_vpe_value = xtc_db_prepare_input($_POST['products_vpe']);
    // Geändert am 24.12.2010 von CM: Sortierreihenfolge über Connector veränderbar
    if (isset($_POST['products_sort']))
        $products_sort = xtc_db_prepare_input($_POST['products_sort']);
    if (isset($_POST['products_startpage_sort']))
        $products_startpage_sort = xtc_db_prepare_input($_POST['products_startpage_sort']);
    // Geändert am 19.01.2012 von CM: 
    if (isset($_POST['products_startpage']))
        $products_startpage = intval($_POST['products_startpage']);
    
    // Geändert am 19.01.2012 von CM: Lieferzeit übernehmen
    if(isset($_POST['products_delivery_time']))
    {
        if(!empty($_POST['products_delivery_time']))
        {
            $products_delivery_time = xtc_db_prepare_input($_POST['products_delivery_time']);
            $res = xtc_db_query("SELECT shipping_status_id FROM " . TABLE_SHIPPING_STATUS . " "
                               ."WHERE shipping_status_name LIKE '" . xtc_db_input($products_delivery_time) . "' "
                               ."OR shipping_status_name LIKE 'ca. " . xtc_db_input($products_delivery_time) . "'");
            if($row = xtc_db_fetch_array($res))
                $products_shippingtime = $row['shipping_status_id'];
            else
            {
                // Geändert am 20.01.2012 von CM: ID-Feld ist nicht autoincrement
                $res = xtc_db_query("SELECT MAX(shipping_status_id)+1 AS newId FROM " . TABLE_SHIPPING_STATUS);
                if($row = xtc_db_fetch_array($res))
                {
                    $status_id = $row["newId"];
                    
                    xtc_db_query("INSERT INTO " . TABLE_SHIPPING_STATUS . " (shipping_status_id, language_id, shipping_status_name) VALUES "
                               . "(" . $status_id . "," . $DefaultLangID . ",'" . xtc_db_input($products_delivery_time) . "')");

                    $products_shippingtime = $status_id;
                }
            }
        }else
            $products_shippingtime = 0;
    }

    // Geändert am 15.12.2011 von CM: enfernen wird von Auction Studio nicht benötigt und stört evtl den Ablauf
    //if (file_exists('cao_produpd_1.php')) {
        //include('cao_produpd_1.php');
    //}

    // Comment: SWITCH_MWST nun an der richtigen Var. ; TKI 2005-08-24
    if (SWITCH_MWST == true) {
        // switch IDs
        if ($products_tax_class_id == 1) {
            $products_tax_class_id = 2;
        } else {
            if ($products_tax_class_id == 2) {
                $products_tax_class_id = 1;
            }
        }
    }

    // Geändert am 11.07.2011 von CM: Auction Studio übergibt den Hersteller-Namen
    //if (isset($_POST['manufacturers_id']))
    //    $manufacturers_id = xtc_db_prepare_input($_POST['manufacturers_id']);
    if(!empty($_POST['manufacturers_name']))
    {
        $manufacturers_name = xtc_db_prepare_input($_POST['manufacturers_name']);
        
        $res = xtc_db_query("SELECT manufacturers_id FROM " . TABLE_MANUFACTURERS . " WHERE manufacturers_name = '" . xtc_db_input($manufacturers_name) . "'");

        if($row = xtc_db_fetch_array($res))
            $manufacturers_id = $row["manufacturers_id"];
        else
        {
            xtc_db_query("INSERT INTO " . TABLE_MANUFACTURERS . "(manufacturers_name, date_added, last_modified) VALUES ('" . xtc_db_input($manufacturers_name) . "',NOW(),NOW())");
            $manufacturers_id = xtc_db_insert_id();
			// Hinzugefügt am 2019-01-09 von CM: Gambio 3.11.2.0
			if(table_exists(TABLE_MANUFACTURERS))
			{
				foreach($languages_array as $lang)
					xtc_db_query("INSERT INTO " . TABLE_MANUFACTURERS_INFO . " (manufacturers_id, languages_id) VALUES (" . $manufacturers_id . "," . $lang["id"] . ")");
			}
        }
    }

    $products_date_available = (date('Y-m-d') < $products_date_available) ? $products_date_available : 'null';

    $sql_data_array = array('products_id' => $products_id,
        'products_quantity' => $products_quantity,
        'products_model' => $products_model,
        'products_image' => ($products_image == 'none') ? '' : $products_image,
        'products_price' => $products_price,
        'products_date_available' => $products_date_available,
        'products_weight' => $products_weight,
        'products_status' => $products_status,
        'products_ean' => $products_ean,
        'products_fsk18' => $products_fsk18,
        'products_shippingtime' => $products_shippingtime,
        'products_tax_class_id' => $products_tax_class_id,
        'manufacturers_id' => $manufacturers_id);

    if ((defined('TABLE_PRODUCTS_VPE')) and (USE_VPE == true)) {
        $products_vpe_status = $products_vpe_id > 0 && $products_vpe_value > 0;
        $sql_data_array = array_merge($sql_data_array, array('products_vpe' => $products_vpe_id, 'products_vpe_value' => $products_vpe_value, 'products_vpe_status' => $products_vpe_status));
    }
    
    // Geändert am 24.12.2010 von CM: Sortierreihenfolge über Connector veränderbar
    // Geändert am 19.01.2012 von CM: 
    //$sql_data_array = array_merge($sql_data_array, array('products_sort' => $products_sort, 'products_startpage_sort' => $products_startpage_sort));
    $sql_data_array = array_merge($sql_data_array, array('products_sort' => $products_sort, 'products_startpage_sort' => $products_startpage_sort, 'products_startpage' => $products_startpage));

    if ($exists == 0) { // Neuanlage (ID wird an CAO zurueckgegeben !!!)
        // set groupaccees

        $permission_sql = 'show columns from ' . TABLE_PRODUCTS . ' like "group_permission_%"';
        $permission_query = xtc_db_query($permission_sql);

        if (xtc_db_num_rows($permission_query)) {
            // ist XTC 3.0.4
            $permission_array = array();
            while ($permissions = xtc_db_fetch_array($permission_query)) {
                $permission_array = array_merge($permission_array, array($permissions['Field'] => '1'));
            }

            $insert_sql_data = array('products_date_added' => 'now()',
                'products_shippingtime' => 1);

            $insert_sql_data = array_merge($insert_sql_data, $permission_array);
        } else {
            // XTC bis 3.0.3
            $customers_statuses_array = array(array());
            $customers_statuses_query = xtc_db_query("select customers_status_id,
	                                             customers_status_name
	                                             from " . TABLE_CUSTOMERS_STATUS . "
	                                             where language_id = '" . $DefaultLangID . "' order by
	                                             customers_status_id");
            $i = 1;        // this is changed from 0 to 1 in cs v1.2
            while ($customers_statuses = xtc_db_fetch_array($customers_statuses_query)) {
                $i = $customers_statuses['customers_status_id'];
                $customers_statuses_array[$i] = array('id' => $customers_statuses['customers_status_id'],
                    'text' => $customers_statuses['customers_status_name']);
            }

            $group_ids = 'c_all_group,';
            for ($i = 0; $n = sizeof($customers_statuses_array), $i < $n; $i++) {
                $group_ids .='c_' . $customers_statuses_array[$i]['id'] . '_group,';
            }

            $insert_sql_data = array('products_date_added' => 'now()',
                'products_shippingtime' => 1,
                'group_ids' => $group_ids);
        }

        $mode = 'APPEND';

        $sql_data_array = array_merge($sql_data_array, $insert_sql_data);

        // insert data
        xtc_db_perform(TABLE_PRODUCTS, $sql_data_array);

        $products_id = xtc_db_insert_id();
    } elseif ($exists == 1) { //Update
        $mode = 'UPDATE';
        $update_sql_data = array('products_last_modified' => 'now()');
        $sql_data_array = array_merge($sql_data_array, $update_sql_data);

        // update data
        xtc_db_perform(TABLE_PRODUCTS, $sql_data_array, 'update', 'products_id = \'' . xtc_db_input($products_id) . '\'');
    }

    ////////////////////////////////
    // Beschreibung importieren
    ////////////////////////////////

    $languages = $languages_array;
    for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
        $language_id = $languages[$i]['id'];

        // Bestehende Daten laden
        $desc_query = xtc_db_query("select
	                             products_id,
	                             products_name,
	                             products_description,
	                             products_short_description,
	                             products_meta_title,
	                             products_meta_description,
	                             products_meta_keywords,
                                     products_keywords,
	                             products_url,
	                             products_viewed,
	                             language_id
	                             from " .
                TABLE_PRODUCTS_DESCRIPTION . "
	                             where products_id='" . $products_id . "'
	                             and language_id='" . $language_id . "'");

        if ($desc = xtc_db_fetch_array($desc_query)) {
            $products_name = $desc['products_name'];
            $products_description = $desc['products_description'];
            $products_short_description = $desc['products_short_description'];
            $products_meta_title = $desc['products_meta_title'];
            $products_meta_description = $desc['products_meta_description'];
            $products_meta_keywords = $desc['products_meta_keywords'];
            // Hinzugefügt am 15.11.2011 von CM: 
            $products_keywords = $desc['products_keywords'];
            
            $products_url = $desc['products_url'];
        }

        // uebergebene Daten einsetzen
        // Geändert am 23.12.2010 von CM: Daten aus dieser Sprache übernehmen
        if (isset($_POST['products_name'][$language_id]) && trim($_POST['products_name'][$language_id]) != "")
            $products_name = xtc_db_prepare_input($_POST['products_name'][$language_id]);

        if (isset($_POST['products_description'][$language_id]) && trim($_POST['products_description'][$language_id]) != "")
            $products_description = xtc_db_prepare_input($_POST['products_description'][$language_id]);

        if (isset($_POST['products_short_description'][$language_id]) && trim($_POST['products_short_description'][$language_id]) != "")
            $products_short_description = xtc_db_prepare_input($_POST['products_short_description'][$language_id]);

        if (isset($_POST['products_meta_title'][$language_id]) && trim($_POST['products_meta_title'][$language_id]) != "")
            $products_meta_title = xtc_db_prepare_input($_POST['products_meta_title'][$language_id]);

        if (isset($_POST['products_meta_description'][$language_id]) && trim($_POST['products_meta_description'][$language_id]) != "")
            $products_meta_description = xtc_db_prepare_input($_POST['products_meta_description'][$language_id]);

        if (isset($_POST['products_meta_keywords'][$language_id]) && trim($_POST['products_meta_keywords'][$language_id]) != "")
            $products_meta_keywords = xtc_db_prepare_input($_POST['products_meta_keywords'][$language_id]);

        if (isset($_POST['products_url'][$language_id]) && trim($_POST['products_url'][$language_id]) != "")
            $products_url = xtc_db_prepare_input($_POST['products_url'][$language_id]);

        // Hinzugefügt am 15.11.2011 von CM: 
        if (isset($_POST['products_keywords'][$language_id]) && trim($_POST['products_keywords'][$language_id]) != "")
            $products_keywords = xtc_db_prepare_input($_POST['products_keywords'][$language_id]);
        
        //NEU 20051004 JP
        if (isset($_POST['products_shop_long_description'][$language_id]) && trim($_POST['products_shop_long_description'][$language_id]) != "")
            $products_description = xtc_db_prepare_input($_POST['products_shop_long_description'][$language_id]);

        if (isset($_POST['products_shop_short_description'][$language_id]) && trim($_POST['products_shop_short_description'][$language_id]) != "")
            $products_short_description = xtc_db_prepare_input($_POST['products_shop_short_description'][$language_id]);

        // Hinzugefügt am 15.11.2011 von CM: In products_url darf kein führendes http:// sein
        $products_url = preg_replace("/^http\:\/\//","",$products_url);
        

        $sql_data_array = array('products_name' => $products_name,
            'products_description' => $products_description,
            'products_short_description' => $products_short_description,
            'products_meta_title' => $products_meta_title,
            'products_meta_description' => $products_meta_description,
            'products_meta_keywords' => $products_meta_keywords,
            // Hinzugefügt am 15.11.2011 von CM: 
            'products_keywords' => $products_keywords,
            
            'products_url' => $products_url);

        if ($exists == 0) { // Insert
            $insert_sql_data = array('products_id' => $products_id,
                'language_id' => $language_id);

            $sql_data_array = array_merge($sql_data_array, $insert_sql_data);
            xtc_db_perform(TABLE_PRODUCTS_DESCRIPTION, $sql_data_array);
        }
        // Geändert am 23.12.2010 von CM: auch andere sprachen updaten
        else {
            // Nur die Daten in der akt. Sprache aendern !
            xtc_db_perform(TABLE_PRODUCTS_DESCRIPTION, $sql_data_array, 'update', 'products_id = \'' . xtc_db_input($products_id) . '\' and language_id = \'' . $language_id . '\'');
        }
    }

    ////////////////////////////////
    // Zusätzliche Bilder übertragen
    ////////////////////////////////

    // Geändert am 29.12.2010 von CM: immer mehr bilder akzeptieren
    if (defined('TABLE_PRODUCTS_IMAGES')) {
        // Das erste Bild steht direkt in der Products-Tabelle alle anderen über Zuordnungstabelle

        // Geändert am 22.01.2013 von CM: 
        // Geändert am 22.01.2013 von CM: link_image_to_product immer aufrufen -> nicht übergebene Bilder werden gelöscht
        // -> Ist products_image nicht gesetzt, werden die Bilder nicht aktualisiert
        if (isset($_POST['products_image']))
        {
            link_image_to_product($_POST['products_image_med'], $products_id, 1);
            link_image_to_product($_POST['products_image_large'], $products_id, 2);

            // Geändert am 23.12.2010 von CM: restlichen 9 Bilder unterstützen
            // -> link_image_to_product löscht bilder die nicht übergeben wurden
            for ($imgNr = 3; $imgNr < 12; $imgNr++)
                link_image_to_product($_POST['products_image_additional'][$imgNr], $products_id, $imgNr);
        }
    }

    ////////////////////////////////
    // Angebots-Preis importieren
    ////////////////////////////////
    // Geändert am 19.07.2011 von CM: Angebotspreis übertragen
    if(isset($_POST['specials_price']) && isset($_POST['specials_price_from']) && isset($_POST['specials_price_to']))
    {
        //Alle Angebotspreise für den Artikel löschen
        xtc_db_query("DELETE FROM " . TABLE_SPECIALS . " WHERE products_id = " . $products_id);

        // Geändert am 02.02.2012 von CM: Angebotspreis wird immer angezeigt, wenn er hinzugefügt wurde und aktiv gesetzt wird
        // -> Nur aktiv setzten, wenn specials_price_from erreicht wurde
        //if($_POST['specials_price'] > 0)
        $special_price_from = xtc_db_prepare_input($_POST['specials_price_from']);
        $special_price_to = xtc_db_prepare_input($_POST['specials_price_to']);
        $special_price = xtc_db_prepare_input($_POST["specials_price"]);
        
        $dtNow = new DateTime();
        $dtSpecialsPriceFrom = new DateTime($special_price_from);
         
        if($_POST['specials_price'] > 0 && $dtSpecialsPriceFrom <= $dtNow)
                xtc_db_query("INSERT INTO " . TABLE_SPECIALS . " (products_id,specials_new_products_price,specials_date_added,expires_date,status) VALUES (" . $products_id . "," . xtc_db_input($special_price) . ",'" . xtc_db_input($special_price_from) . "','" . xtc_db_input($special_price_to) . "',1)");
    }
    
    ////////////////////////////////
    // Google-Products-Categories
    //////////////////////////////// 
    if(isset($_POST['google_products_cat']) && table_exists('products_google_categories'))
    {
        $gcat_query = xtc_db_query("SELECT * FROM " . TABLE_PRODUCTS_GOOGLE_CATEGORIES . " WHERE products_id = " . $products_id);
        if($gcatrs = xtc_db_fetch_array($gcat_query))
        {
            //Aktualisieren
            if($gcatrs['google_category'] != $_POST['google_products_cat'])
                xtc_db_query("UPDATE " . TABLE_PRODUCTS_GOOGLE_CATEGORIES . " SET google_category = '" . xtc_db_prepare_input($_POST['google_products_cat']) . "' WHERE products_id = " . $products_id);
        }else
        {
            //Hinzufügen
            xtc_db_query("INSERT INTO " . TABLE_PRODUCTS_GOOGLE_CATEGORIES . " (products_id, google_category) VALUES (" . $products_id . ",'" . xtc_db_prepare_input($_POST['google_products_cat']) . "')");
        }
    }

    ////////////////////////////////
    // Artikel-Filter
    //////////////////////////////// 
    if(isset($_POST['products_features']))
    {
        //Ab Gambio 2.1.x.x
        $FeatureSetSupported = table_exists(TABLE_FEATURE_SET);
        //Vor Gambio 2.1.x.x
        $FeaturePerProductSupported = table_exists(TABLE_PRODUCTS_FEATURE_VALUE);
        
        if($FeatureSetSupported || $FeaturePerProductSupported)
        {
            //Features anlegen
            $feature_assignment_data = array();
            
            foreach($_POST['products_features'] as $feature)
            {
                $feature_name = xtc_db_prepare_input($feature["name"]);
                $feature_langid = intval($feature["langid"]);

                $query = xtc_db_query("SELECT feature_id FROM " . TABLE_FEATURE_DESCRIPTION . " WHERE UPPER(feature_name) = '" . strtoupper($feature_name) . "' AND language_id = " . $feature_langid);
                if($res = xtc_db_fetch_array($query))
                    $feature_id = $res["feature_id"];
                else
                {
                    xtc_db_query("INSERT INTO " . TABLE_FEATURE . " () VALUES ()");
                    $feature_id = xtc_db_insert_id();                
                    xtc_db_query("INSERT INTO " . TABLE_FEATURE_DESCRIPTION . "(feature_id, language_id, feature_name) VALUES (" . $feature_id . "," . $feature_langid . ",'" . $feature_name . "')");
                }

                foreach($feature["values"] as $value)
                {
                    $query = xtc_db_query("SELECT fvd.feature_value_id FROM " . TABLE_FEATURE_VALUE_DESCRIPTION . " AS fvd"
                            . " INNER JOIN " . TABLE_FEATURE_VALUE . " AS fv ON (fv.feature_value_id = fvd.feature_value_id) "
                            . " WHERE UPPER(fvd.feature_value_text) = '" . strtoupper($value) . "' AND fvd.language_id = " . $feature_langid . " AND fv.feature_id = " . $feature_id);

                    if($res = xtc_db_fetch_array($query))
                        $feature_value_id = $res["feature_value_id"];
                    else
                    {
                        xtc_db_query("INSERT INTO " . TABLE_FEATURE_VALUE . " (feature_id, sort_order) VALUES (" . $feature_id . ",0)");
                        $feature_value_id = xtc_db_insert_id();
                        xtc_db_query("INSERT INTO " . TABLE_FEATURE_VALUE_DESCRIPTION . " (feature_value_id, language_id, feature_value_text) VALUES (" . $feature_value_id . "," . $feature_langid . ",'" . $value . "')");
                    }

                    $feature_assignment_data[$feature_id][] = $feature_value_id;
                }
            }
        }
        
        //Zuordnung zu den Produkten schaffen
        if($FeatureSetSupported)
        {
            //Ab Gambio 2.1.x.x
            
            xtc_db_query("DELETE FROM " . TABLE_FEATURE_SET_TO_PRODUCTS . " WHERE products_id = " . $products_id);

            $feature_value_ids = array();
            foreach($feature_assignment_data as $feature_id => $feature_set_value_ids)
                $feature_value_ids = array_merge ($feature_value_ids, $feature_set_value_ids);
            
            sort($feature_value_ids, SORT_NUMERIC);
            $feature_values_index = "-" . join("--",$feature_value_ids) . "-";

            //Eventuell vorhandenes feature_set verwenden
            $query = xtc_db_query("SELECT feature_set_id FROM " . TABLE_FEATURE_INDEX . " WHERE feature_value_index = '" . $feature_values_index . "'");
            if($res = xtc_db_fetch_array($query))
                $feature_set_id = $res["feature_set_id"];
            else
            {
                //Kein passendes feature_set vorhanden -> neues anlegen
                xtc_db_query("INSERT INTO " . TABLE_FEATURE_SET . " () VALUES ()");
                $feature_set_id = xtc_db_insert_id();
                foreach($feature_value_ids as $feature_value_id)
                    xtc_db_query("INSERT INTO " . TABLE_FEATURE_SET_VALUES . " (feature_set_id, feature_value_id) VALUES (" . $feature_set_id . "," . $feature_value_id . ")");

                xtc_db_query("INSERT INTO " . TABLE_FEATURE_INDEX . "(feature_set_id, date_created, feature_value_index) VALUES (" . $feature_set_id . ",CURRENT_TIMESTAMP,'" . $feature_values_index . "')");
            }

            xtc_db_query("INSERT INTO " . TABLE_FEATURE_SET_TO_PRODUCTS . " (feature_set_id, products_id) VALUES (" . $feature_set_id . "," . $products_id . ")");
            
            //Nicht mehr verwendete Sets löschen
            xtc_db_query("DELETE fs,fsv,fi FROM " . TABLE_FEATURE_SET . " fs "
                    . " LEFT JOIN " . TABLE_FEATURE_SET_VALUES . " fsv ON (fs.feature_set_id = fsv.feature_set_id)"
                    . " LEFT JOIN " . TABLE_FEATURE_INDEX . " fi ON (fs.feature_set_id = fi.feature_set_id)"
                    . " WHERE fs.feature_set_id NOT IN (SELECT fstp.feature_set_id FROM " . TABLE_FEATURE_SET_TO_PRODUCTS . " fstp)");
        }
        else if($FeaturePerProductSupported)
        {
            //Vor Gambio 2.1.x.x
            
            xtc_db_query("DELETE FROM " . TABLE_PRODUCTS_FEATURE_VALUE . " WHERE products_id = " . $products_id);
            
            foreach($feature_assignment_data as $feature_id => $feature_value_ids)
            {
                foreach($feature_value_ids as $feature_value_id)
                    xtc_db_query("INSERT INTO " . TABLE_PRODUCTS_FEATURE_VALUE . " (feature_value_id, products_id) VALUES (" . $feature_value_id . "," . $products_id . ")");
            }
        }
    }
    
    xtc_clear_cache_after_products_modifed($products_id);
    
    // Geändert am 14.12.2011 von CM: entfernen, stört eventuell den geänderten Ablauf des AuctionStudio-Connectors
    //if (file_exists('cao_produpd_2.php')) {
    //    include('cao_produpd_2.php');
    //}

    print_xml_status(0, $_POST['action'], 'OK', $mode, 'PRODUCTS_ID', $products_id);
}

//--------------------------------------------------------------

function ProductsErase() {
    global $_POST;

    $ProdID = intval($_POST['prodid']);
    if (isset($ProdID)) {
        // ProductsToCategieries loeschen bei denen die products_id = ... ist

        // Geändert am 27.07.2011 von CM: Varianten in der Attribut-Tabelle löschen
        // -> ProdID enthält dann die AttributID
        if(isset($_POST["is_variation"]) && $_POST["is_variation"] == "1")
            xtc_db_query("DELETE FROM " . TABLE_PRODUCTS_ATTRIBUTES . " WHERE products_attributes_id = " . $ProdID);
        else
        {
            $res1 = xtc_db_query("delete from " . TABLE_PRODUCTS_TO_CATEGORIES . " where products_id='" . $ProdID . "'");

            // Product loeschen
            xtc_remove_product($ProdID);
        }
        $code = 0;
        $message = 'OK';
    } else {
        $code = 99;
        $message = 'FAILED';
    }
    print_xml_status(0, $_POST['action'], 'OK', '', 'SQL_RES1', $res1);
}

//--------------------------------------------------------------

function ProductsSpecialPriceUpdate() {
    global $_POST;

    $ProdID = xtc_db_prepare_input($_POST['prodid']);

    $Price = xtc_db_prepare_input($_POST['price']);
    $Status = xtc_db_prepare_input($_POST['status']);
    $Expire = xtc_db_prepare_input($_POST['expired']);

    if (isset($ProdID)) {
        /*
          1. Ermitteln ob Produkt bereits einen Spezialpreis hat
          2. wenn JA -> Update / NEIN -> INSERT
         */
        $sp_sql = "select specials_id from " . TABLE_SPECIALS . " " .
            "where products_id='" . (int) $ProdID . "'";
        $sp_query = xtc_db_query($sql);

        if ($sp = xtc_db_fetch_array($sp_query)) {
            // es existiert bereits ein Datensatz -> Update
            $SpecialID = $sp['specials_id'];

            xtc_db_query(
                "update " . TABLE_SPECIALS .
                " set specials_new_products_price = '" . $Price . "'," .
                " specials_last_modified = now()," .
                " expires_date = '" . $Expire .
                "' where specials_id = '" . (int) $SpecialID . "'");

            print_xml_status(0, $_POST['action'], 'OK', 'UPDATE', '', '');
        } else {
            // Neuanlage
            xtc_db_query(
                "insert into " . TABLE_SPECIALS .
                " (products_id, specials_new_products_price, specials_date_added, expires_date, status) " .
                " values ('" . (int) $ProdID . "', '" . $Price . "', now(), '" . $Expire . "', '1')");

            print_xml_status(0, $_POST['action'], 'OK', 'APPEND', '', '');
        }
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function ProductsSpecialPriceErase() {
    global $_POST;

    $ProdID = intval($_POST['prodid']);
    if (isset($ProdID)) {
        xtc_db_query("delete from " . TABLE_SPECIALS . " where products_id = '" . $ProdID . "'");
        print_xml_status(0, $_POST['action'], 'OK', '', '', '');
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function CategoriesUpdate() {
    global $_POST, $DefaultLangID;

    $CatID = xtc_db_prepare_input($_POST['catid']);
    $ParentID = xtc_db_prepare_input($_POST['parentid']);

    if (isset($ParentID) && isset($CatID)) {
        // Kategorie laden
        $SQL = "select categories_id, parent_id, date_added, sort_order, categories_image " .
            "from " . TABLE_CATEGORIES . " where categories_id='" . $CatID . "'";


        $count_query = xtc_db_query($SQL);
        if ($categorie = xtc_db_fetch_array($count_query)) {
            $exists = 1;

            $ParentID = $categorie['parent_id'];
            $Sort = $categorie['sort_order'];
            $Image = $categorie['categories_image'];
        }
        else
            $exists = 0;

        // Variablen nur ueberschreiben wenn als Parameter vorhanden !!!
        if (isset($_POST['parentid']))
            $ParentID = xtc_db_prepare_input($_POST['parentid']);
        if (isset($_POST['sort']))
            $Sort = xtc_db_prepare_input($_POST['sort']);
        if (isset($_POST['image']))
            $Image = xtc_db_prepare_input($_POST['image']);


        $sql_data_array = array('categories_id' => $CatID,
            'parent_id' => $ParentID,
            'sort_order' => $Sort,
            'categories_image' => $Image,
            'last_modified' => 'now()');
			
		// Hinzugefügt am 2018-06-13 von CM: In xtcmod könnte es noch categories_status geben welcher aktiviert werden muss
		if(column_exists(TABLE_CATEGORIES, "categories_status"))
			$sql_data_array["categories_status"] = 1;

        if ($exists == 0) { // Neuanlage
            $mode = 'APPEND';

            // set groupaccees
            $permission_sql = 'show columns from ' . TABLE_CATEGORIES . ' like "group_permission_%"';
            $permission_query = xtc_db_query($permission_sql);

            if (xtc_db_num_rows($permission_query)) {
                // ist XTC 3.0.4
                $permission_array = array();
                while ($permissions = xtc_db_fetch_array($permission_query)) {
                    $permission_array = array_merge($permission_array, array($permissions['Field'] => '1'));
                }

                $insert_sql_data = array('date_added' => 'now()');

                $insert_sql_data = array_merge($insert_sql_data, $permission_array);
            } else {
                // XTC bis 3.0.3
                $customers_statuses_array = array(array());
                $customers_statuses_query = xtc_db_query("select customers_status_id,
	                                               customers_status_name
	                                               from " . TABLE_CUSTOMERS_STATUS . "
	                                               where language_id = '" . $DefaultLangID . "' order by
	                                               customers_status_id");
                $i = 1;        // this is changed from 0 to 1 in cs v1.2
                while ($customers_statuses = xtc_db_fetch_array($customers_statuses_query)) {
                    $i = $customers_statuses['customers_status_id'];
                    $customers_statuses_array[$i] = array('id' => $customers_statuses['customers_status_id'],
                        'text' => $customers_statuses['customers_status_name']);
                }

                $group_ids = 'c_all_group,';
                for ($i = 0; $n = sizeof($customers_statuses_array), $i < $n; $i++) {
                    $group_ids .='c_' . $customers_statuses_array[$i]['id'] . '_group,';
                }
                $insert_sql_data = array('date_added' => 'now()',
                    'group_ids' => $group_ids);
            }

            $sql_data_array = /* xtc_ */array_merge($sql_data_array, $insert_sql_data);

            xtc_db_perform(TABLE_CATEGORIES, $sql_data_array);
        } elseif ($exists == 1) { //Update
            $mode = 'UPDATE';

            xtc_db_perform(TABLE_CATEGORIES, $sql_data_array, 'update', 'categories_id = \'' . xtc_db_input($CatID) . '\'');
        }

        //$languages = xtc_get_languages();

        $languages_query = xtc_db_query("select languages_id, name, code, image, directory from " . TABLE_LANGUAGES . " order by sort_order");
        while ($languages = xtc_db_fetch_array($languages_query)) {
            $languages_array[] = array('id' => $languages['languages_id'],
                'name' => $languages['name'],
                'code' => $languages['code'],
                'image' => $languages['image'],
                'directory' => $languages['directory']);
        }

        $languages = $languages_array;

        for ($i = 0, $n = sizeof($languages); $i < $n; $i++) {
            $language_id = $languages[$i]['id'];

            // Bestehende Daten laden
            $SQL = "select categories_id,language_id,categories_name,categories_description,categories_heading_title," .
                "categories_meta_title,categories_meta_description,categories_meta_keywords";

            $desc_query = xtc_db_query($SQL . " from " . TABLE_CATEGORIES_DESCRIPTION . " where categories_id='" . $CatID . "' and language_id='" . $language_id . "'");
            if ($desc = xtc_db_fetch_array($desc_query)) {
                $categories_name = $desc['categories_name'];
                $categories_description = $desc['$categories_description'];
                $categories_heading_title = $desc['categories_heading_title'];
                $categories_meta_title = $desc['categories_meta_title'];
                $categories_meta_description = $desc['categories_meta_description'];
                $categories_meta_keywords = $desc['categories_meta_keywords'];
            }

            // uebergebene Daten einsetzen
            if (isset($_POST['name']))
                $categories_name = xtc_db_prepare_input(UrlDecode($_POST['name']));
            if (isset($_POST['descr']))
                $categories_description = xtc_db_prepare_input(UrlDecode($_POST['descr']));
            if (isset($_POST['categories_heading_title']))
                $categories_heading_title = xtc_db_prepare_input(UrlDecode($_POST['categories_heading_title']));
            if (isset($_POST['categories_meta_title']))
                $categories_meta_title = xtc_db_prepare_input(UrlDecode($_POST['categories_meta_title']));
            if (isset($_POST['categories_meta_description']))
                $categories_meta_description = xtc_db_prepare_input(UrlDecode($_POST['categories_meta_description']));
            if (isset($_POST['categories_meta_keywords']))
                $categories_meta_keywords = xtc_db_prepare_input(UrlDecode($_POST['categories_meta_keywords']));

            $sql_data_array = array('categories_name' => $categories_name,
                'categories_description' => $categories_description,
                'categories_heading_title' => $categories_heading_title,
                'categories_meta_title' => $categories_meta_title,
                'categories_meta_description' => $categories_meta_description,
                'categories_meta_keywords' => $categories_meta_keywords);

            if ($exists == 0) { // Insert
                $insert_sql_data = array('categories_id' => $CatID,
                    'language_id' => $language_id);

                $sql_data_array = /* xtc_ */array_merge($sql_data_array, $insert_sql_data);
                xtc_db_perform(TABLE_CATEGORIES_DESCRIPTION, $sql_data_array);
            } elseif (($exists == 1) and ($language_id == $DefaultLangID)) { // Update
                // Nur 1 Sprache aktualisieren
                xtc_db_perform(TABLE_CATEGORIES_DESCRIPTION, $sql_data_array, 'update', 'categories_id = \'' . xtc_db_input($CatID) . '\' and language_id = \'' . $language_id . '\'');
            }
        }
        print_xml_status(0, $_POST['action'], 'OK', $mode, '', '');
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function CategoriesErase() {
    global $_POST;

    $CatID = intval($_POST['catid']);

    if (isset($CatID)) {
        // Categorie loeschen
        $res1 = xtc_db_query("delete from " . TABLE_CATEGORIES . " where categories_id='" . $CatID . "'");
        // ProductsToCategieries loeschen bei denen die Categorie = ... ist
        $res2 = xtc_db_query("delete from " . TABLE_PRODUCTS_TO_CATEGORIES . " where categories_id='" . $CatID . "'");
        // CategieriesDescription loeschenm bei denen die Categorie = ... ist
        $res3 = xtc_db_query("delete from " . TABLE_CATEGORIES_DESCRIPTION . " where categories_id='" . $CatID . "'");

        print_xml_status(0, $_POST['action'], 'OK', '', 'SQL_RES1', $res1);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function Prod2CatUpdate() {
    global $_POST;

    $ProdID = intval($_POST['prodid']);
    $CatID = intval($_POST['catid']);

    if (isset($ProdID) && isset($CatID)) {
        $res = xtc_db_query("replace into " . TABLE_PRODUCTS_TO_CATEGORIES . " (products_id, categories_id) Values ('" . $ProdID . "', '" . $CatID . "')");
        xtc_clear_cache_after_categories_modified($ProdID);
        print_xml_status(0, $_POST['action'], 'OK', '', 'SQL_RES', $res);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function Prod2CatErase() {
    global $_POST;

    $ProdID = intval($_POST['prodid']);
    $CatID = intval($_POST['catid']);

    if (isset($ProdID) && isset($CatID)) {
        $res = xtc_db_query("delete from " . TABLE_PRODUCTS_TO_CATEGORIES . " where products_id='" . $ProdID . "' and categories_id='" . $CatID . "'");
        xtc_clear_cache_after_categories_modified($ProdID);
        print_xml_status(0, $_POST['action'], 'OK', '', 'SQL_RES', $res);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

// Hinzugefügt am 27.02.2013 von CM: 
function Prod2CatEraseAll() {
    global $_POST;
    
    $ProdID = intval($_POST['prodid']);
    
    if(!empty($ProdID))
    {
        $res = xtc_db_query("delete from " . TABLE_PRODUCTS_TO_CATEGORIES . " where products_id='" . $ProdID . "'");
        xtc_clear_cache_after_categories_modified($ProdID);
        print_xml_status(0,$_POST['action'], 'OK', '', 'SQL_RES', $res);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function OrderUpdate() {
    global $_POST, $DefaultLangID;

    $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" . "\n";

    if ((isset($_POST['order_id'])) && (isset($_POST['status']))) {
        // Per Post übergebene Variablen
        $oID = $_POST['order_id'];
        $status = $_POST['status'];
        $comments = xtc_db_prepare_input($_POST['comments']);

        //Status überprüfen
        $check_status_query = xtc_db_query("select * from " . TABLE_ORDERS . " where orders_id = '" . xtc_db_input($oID) . "'");
        if ($check_status = xtc_db_fetch_array($check_status_query)) {
            if ($check_status['orders_status'] != $status || $comments != '') {
                xtc_db_query("update " . TABLE_ORDERS . " set orders_status = '" . xtc_db_input($status) . "', last_modified = now() where orders_id = '" . xtc_db_input($oID) . "'");
                $customer_notified = '0';
                if ($_POST['notify'] == 'on') {
                    // Falls eine Sprach ID zur Order existiert die Emailbestätigung in dieser Sprache ausführen
                    if (isset($check_status['orders_language_id']) && $check_status['orders_language_id'] > 0) {
                        $orders_status_query = xtc_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . $check_status['orders_language_id'] . "'");
                        if (xtc_db_num_rows($orders_status_query) == 0) {
                            $orders_status_query = xtc_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . $languages_id . "'");
                        }
                    } else {
                        $orders_status_query = xtc_db_query("select orders_status_id, orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . $languages_id . "'");
                    }
                    $orders_statuses = array();
                    $orders_status_array = array();
                    while ($orders_status = xtc_db_fetch_array($orders_status_query)) {
                        $orders_statuses[] = array('id' => $orders_status['orders_status_id'],
                            'text' => $orders_status['orders_status_name']);
                        $orders_status_array[$orders_status['orders_status_id']] = $orders_status['orders_status_name'];
                    }
                    // status query
                    $orders_status_query = xtc_db_query("select orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id = '" . $DefaultLangID . "' and orders_status_id='" . $status . "'");
                    $o_status = xtc_db_fetch_array($orders_status_query);
                    $o_status = $o_status['orders_status_name'];

                    //ok lets generate the html/txt mail from Template
                    if ($_POST['notify_comments'] == 'on') {
                        $notify_comments = sprintf(EMAIL_TEXT_COMMENTS_UPDATE, $comments) . "\n\n";
                    } else {
                        $comments = '';
                    }

                    // require functionblock for mails
                    require_once(DIR_WS_CLASSES . 'class.phpmailer.php');
                    require_once(DIR_FS_INC . 'xtc_php_mail.inc.php');
                    require_once(DIR_FS_INC . 'xtc_add_tax.inc.php');
                    require_once(DIR_FS_INC . 'xtc_not_null.inc.php');
                    require_once(DIR_FS_INC . 'changedataout.inc.php');
                    require_once(DIR_FS_INC . 'xtc_href_link.inc.php');
                    require_once(DIR_FS_INC . 'xtc_date_long.inc.php');
                    require_once(DIR_FS_INC . 'xtc_check_agent.inc.php');
                    $smarty = new Smarty;

                    $smarty->assign('language', $check_status['language']);
                    $smarty->caching = false;
                    $smarty->template_dir = DIR_FS_CATALOG . 'templates';
                    $smarty->compile_dir = DIR_FS_CATALOG . 'templates_c';
                    $smarty->config_dir = DIR_FS_CATALOG . 'lang';
                    $smarty->assign('tpl_path', 'templates/' . CURRENT_TEMPLATE . '/');
                    $smarty->assign('logo_path', HTTP_SERVER . DIR_WS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/img/');
                    $smarty->assign('NAME', $check_status['customers_name']);
                    $smarty->assign('ORDER_NR', $oID);
                    $smarty->assign('ORDER_LINK', xtc_href_link(FILENAME_CATALOG_ACCOUNT_HISTORY_INFO, 'order_id=' . $oID, 'SSL'));
                    $smarty->assign('ORDER_DATE', xtc_date_long($check_status['date_purchased']));
                    $smarty->assign('NOTIFY_COMMENTS', $comments);
                    $smarty->assign('ORDER_STATUS', $o_status);

                    $html_mail = $smarty->fetch(CURRENT_TEMPLATE . '/admin/mail/' . $check_status['language'] . '/change_order_mail.html');
                    $txt_mail = $smarty->fetch(CURRENT_TEMPLATE . '/admin/mail/' . $check_status['language'] . '/change_order_mail.txt');

                    // send mail with html/txt template
                    xtc_php_mail(EMAIL_BILLING_ADDRESS,
                        EMAIL_BILLING_NAME,
                        $check_status['customers_email_address'],
                        $check_status['customers_name'],
                        '',
                        EMAIL_BILLING_REPLY_ADDRESS,
                        EMAIL_BILLING_REPLY_ADDRESS_NAME,
                        '',
                        '',
                        EMAIL_BILLING_SUBJECT,
                        $html_mail,
                        $txt_mail);

                    $customer_notified = '1';
                }
                xtc_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . xtc_db_input($oID) . "', '" . xtc_db_input($status) . "', now(), '" . $customer_notified . "', '" . xtc_db_input($comments) . "')");
                $schema .= '<STATUS>' . "\n" .
                    '<STATUS_DATA>' . "\n" .
                    '<ORDER_ID>' . $oID . '</ORDER_ID>' . "\n" .
                    '<ORDER_STATUS>' . $status . '</ORDER_STATUS>' . "\n" .
                    '<ACTION>' . $_POST['action'] . '</ACTION>' . "\n" .
                    '<CODE>' . '0' . '</CODE>' . "\n" .
                    '<MESSAGE>' . 'OK' . '</MESSAGE>' . "\n" .
                    '</STATUS_DATA>' . "\n" .
                    '</STATUS>' . "\n";
            } else if ($check_status['orders_status'] == $status) {
                // Status ist bereits gesetzt
                $schema .= '<STATUS>' . "\n" .
                    '<STATUS_DATA>' . "\n" .
                    '<ORDER_ID>' . $oID . '</ORDER_ID>' . "\n" .
                    '<ORDER_STATUS>' . $status . '</ORDER_STATUS>' . "\n" .
                    '<ACTION>' . $_POST['action'] . '</ACTION>' . "\n" .
                    '<CODE>' . '1' . '</CODE>' . "\n" .
                    '<MESSAGE>' . 'NO STATUS CHANGE' . '</MESSAGE>' . "\n" .
                    '</STATUS_DATA>' . "\n" .
                    '</STATUS>' . "\n";
            }
        } else {
            // Fehler Order existiert nicht
            $schema .= '<STATUS>' . "\n" .
                '<STATUS_DATA>' . "\n" .
                '<ORDER_ID>' . $oID . '</ORDER_ID>' . "\n" .
                '<ACTION>' . $_POST['action'] . '</ACTION>' . "\n" .
                '<CODE>' . '2' . '</CODE>' . "\n" .
                '<MESSAGE>' . 'ORDER_ID NOT FOUND OR SET' . '</MESSAGE>' . "\n" .
                '</STATUS_DATA>' . "\n" .
                '</STATUS>' . "\n";
        }
    } else {
        $schema = '<?xml version="1.0" encoding="utf-8"?>' . "\n" .
            '<STATUS>' . "\n" .
            '<STATUS_DATA>' . "\n" .
            '<ACTION>' . $_POST['action'] . '</ACTION>' . "\n" .
            '<CODE>' . '99' . '</CODE>' . "\n" .
            '<MESSAGE>' . 'PARAMETER ERROR' . '</MESSAGE>' . "\n" .
            '</STATUS_DATA>' . "\n" .
            '</STATUS>' . "\n\n";
    }
    echo $schema;
}

//--------------------------------------------------------------

function CustomersUpdate() {
    global $_POST, $DefaultLangFolder;

    $customers_id = -1;
    // include PW function
    require_once(DIR_FS_INC . 'xtc_encrypt_password.inc.php');

    if (isset($_POST['cID']))
        $customers_id = intval($_POST['cID']);

    // security check, if user = admin, dont allow to perform changes
    if ($customers_id != -1) {
        $sec_query = xtc_db_query("SELECT customers_status FROM " . TABLE_CUSTOMERS . " where customers_id='" . $customers_id . "'");
        $sec_data = xtc_db_fetch_array($sec_query);
        if ($sec_data['customers_status'] == 0) {
            print_xml_status(120, $_POST['action'], 'CAN NOT CHANGE ADMIN USER!', '', '', '');
            return;
        }
    }
    $sql_customers_data_array = array();
    if (isset($_POST['customers_cid']))
        $sql_customers_data_array['customers_cid'] = $_POST['customers_cid'];
    if (isset($_POST['customers_firstname']))
        $sql_customers_data_array['customers_firstname'] = $_POST['customers_firstname'];
    if (isset($_POST['customers_lastname']))
        $sql_customers_data_array['customers_lastname'] = $_POST['customers_lastname'];
    if (isset($_POST['customers_dob']))
        $sql_customers_data_array['customers_dob'] = $_POST['customers_dob'];
    if (isset($_POST['customers_email']))
        $sql_customers_data_array['customers_email_address'] = $_POST['customers_email'];
    if (isset($_POST['customers_tele']))
        $sql_customers_data_array['customers_telephone'] = $_POST['customers_tele'];
    if (isset($_POST['customers_fax']))
        $sql_customers_data_array['customers_fax'] = $_POST['customers_fax'];
    if (isset($_POST['customers_gender']))
        $sql_customers_data_array['customers_gender'] = $_POST['customers_gender'];

    if (file_exists('cao_custupd_1.php')) {
        include('cao_custupd_1.php');
    }

    if (isset($_POST['customers_password'])) {
        $sql_customers_data_array['customers_password'] = xtc_encrypt_password($_POST['customers_password']);
    }
    $sql_address_data_array = array();
    if (isset($_POST['customers_firstname']))
        $sql_address_data_array['entry_firstname'] = $_POST['customers_firstname'];
    if (isset($_POST['customers_lastname']))
        $sql_address_data_array['entry_lastname'] = $_POST['customers_lastname'];
    if (isset($_POST['customers_company']))
        $sql_address_data_array['entry_company'] = $_POST['customers_company'];
    if (isset($_POST['customers_street']))
        $sql_address_data_array['entry_street_address'] = $_POST['customers_street'];
    if (isset($_POST['customers_city']))
        $sql_address_data_array['entry_city'] = $_POST['customers_city'];
    if (isset($_POST['customers_postcode']))
        $sql_address_data_array['entry_postcode'] = $_POST['customers_postcode'];
    if (isset($_POST['customers_gender']))
        $sql_address_data_array['entry_gender'] = $_POST['customers_gender'];
    if (isset($_POST['customers_country_id']))
        $country_code = $_POST['customers_country_id'];

    $country_query = "SELECT countries_id FROM " . TABLE_COUNTRIES . " WHERE countries_iso_code_2 = '" . $country_code . "' LIMIT 1";
    $country_result = xtc_db_query($country_query);
    $row = xtc_db_fetch_array($country_result);
    $sql_address_data_array['entry_country_id'] = $row['countries_id'];

    $count_query = xtc_db_query("SELECT count(*) as count FROM " . TABLE_CUSTOMERS . " WHERE customers_id='" . (int) $customers_id . "' LIMIT 1");
    $check = xtc_db_fetch_array($count_query);

    if ($check['count'] > 0) {
        $mode = 'UPDATE';
        $address_book_result = xtc_db_query("SELECT customers_default_address_id FROM " . TABLE_CUSTOMERS . " WHERE customers_id = '" . (int) $customers_id . "' LIMIT 1");
        $customer = xtc_db_fetch_array($address_book_result);
        xtc_db_perform(TABLE_CUSTOMERS, $sql_customers_data_array, 'update', "customers_id = '" . xtc_db_input($customers_id) . "' LIMIT 1");
        xtc_db_perform(TABLE_ADDRESS_BOOK, $sql_address_data_array, 'update', "customers_id = '" . xtc_db_input($customers_id) . "' AND address_book_id = '" . $customer['customers_default_address_id'] . "' LIMIT 1");
        xtc_db_query("update " . TABLE_CUSTOMERS_INFO . " set customers_info_date_account_last_modified = now() where customers_info_id = '" . (int) $customers_id . "'  LIMIT 1");
    } else {
        $mode = 'APPEND';
        if (strlen($_POST['customers_password']) == 0) {
            // generate PW if empty
            $pw = xtc_RandomString(8);
            $sql_customers_data_array['customers_password'] = xtc_create_password($pw);
        } else {
            $pw = $_POST['customers_password'];
        }
        xtc_db_perform(TABLE_CUSTOMERS, $sql_customers_data_array);
        $customers_id = xtc_db_insert_id();
        $sql_address_data_array['customers_id'] = $customers_id;
        xtc_db_perform(TABLE_ADDRESS_BOOK, $sql_address_data_array);
        $address_id = xtc_db_insert_id();
        xtc_db_query("update " . TABLE_CUSTOMERS . " set customers_default_address_id = '" . (int) $address_id . "' where customers_id = '" . (int) $customers_id . "'");
        //JP20080401
        if (!isset($_POST['customers_price_level'])) {
            xtc_db_query("update " . TABLE_CUSTOMERS . " set customers_status = '" . STANDARD_GROUP . "' where customers_id = '" . (int) $customers_id . "'");
        }
        xtc_db_query("insert into " . TABLE_CUSTOMERS_INFO . " (customers_info_id, customers_info_number_of_logons, customers_info_date_account_created) values ('" . (int) $customers_id . "', '0', now())");
    }

    if (SEND_ACCOUNT_MAIL == true && $mode == 'APPEND' && $sql_customers_data_array['customers_email_address'] != '') {
        // generate mail for customer if customer=new
        require_once(DIR_WS_CLASSES . 'class.phpmailer.php');
        require_once(DIR_FS_INC . 'xtc_php_mail.inc.php');
        require_once(DIR_FS_INC . 'xtc_add_tax.inc.php');
        require_once(DIR_FS_INC . 'xtc_not_null.inc.php');
        require_once(DIR_FS_INC . 'changedataout.inc.php');
        require_once(DIR_FS_INC . 'xtc_href_link.inc.php');
        require_once(DIR_FS_INC . 'xtc_date_long.inc.php');
        require_once(DIR_FS_INC . 'xtc_check_agent.inc.php');

        require_once(DIR_FS_LANGUAGES . $DefaultLangFolder . '/admin/' . $DefaultLangFolder . '.php');  //JP 20080102


        $smarty = new Smarty;

        //$smarty->assign('language', $check_status['language']);
        $smarty->assign('language', $DefaultLangFolder);

        $smarty->caching = false;
        $smarty->template_dir = DIR_FS_CATALOG . 'templates';
        $smarty->compile_dir = DIR_FS_CATALOG . 'templates_c';
        $smarty->config_dir = DIR_FS_CATALOG . 'lang';
        $smarty->assign('tpl_path', 'templates/' . CURRENT_TEMPLATE . '/');
        $smarty->assign('logo_path', HTTP_SERVER . DIR_WS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/img/');
        $smarty->assign('NAME', $sql_customers_data_array['customers_lastname'] . ' ' . $sql_customers_data_array['customers_firstname']);
        $smarty->assign('EMAIL', $sql_customers_data_array['customers_email_address']);
        $smarty->assign('PASSWORD', $pw);
        //$smarty->assign('language', $DefaultLangFolder);
        $smarty->assign('content', $module_content);
        $smarty->caching = false;

        $html_mail = $smarty->fetch(CURRENT_TEMPLATE . '/admin/mail/' . $DefaultLangFolder . '/create_account_mail.html');
        $txt_mail = $smarty->fetch(CURRENT_TEMPLATE . '/admin/mail/' . $DefaultLangFolder . '/create_account_mail.txt');

        // send mail with html/txt template
        xtc_php_mail(
            EMAIL_SUPPORT_ADDRESS,
            EMAIL_SUPPORT_NAME,
            $sql_customers_data_array['customers_email_address'],
            $sql_customers_data_array['customers_lastname'] . ' ' . $sql_customers_data_array['customers_firstname'],
            '',
            EMAIL_SUPPORT_REPLY_ADDRESS,
            EMAIL_SUPPORT_REPLY_ADDRESS_NAME,
            '',
            '',
            EMAIL_SUPPORT_SUBJECT,
            $html_mail,
            $txt_mail);
    }
    print_xml_status(0, $_POST['action'], 'OK', $mode, 'CUSTOMERS_ID', $customers_id);
}

//--------------------------------------------------------------

function CustomersErase() {
    global $_POST;

    $cID = intval($_POST['cID']);

    $sec_query = xtc_db_query("SELECT customers_status FROM " . TABLE_CUSTOMERS . " where customers_id='" . $cID . "'");
    $sec_data = xtc_db_fetch_array($sec_query);
    if ($sec_data['customers_status'] == 0) {
        print_xml_status(120, $_POST['action'], 'CAN NOT CHANGE ADMIN USER!', '', '', '');
        return;
    }
    if (isset($cID)) {
        xtc_db_query("update " . TABLE_REVIEWS . " set customers_id = null where customers_id = '" . $cID . "'");
        xtc_db_query("delete from " . TABLE_ADDRESS_BOOK . " where customers_id = '" . $cID . "'");
        xtc_db_query("delete from " . TABLE_CUSTOMERS . " where customers_id = '" . $cID . "'");
        xtc_db_query("delete from " . TABLE_CUSTOMERS_INFO . " where customers_info_id = '" . $cID . "'");
        xtc_db_query("delete from " . TABLE_CUSTOMERS_BASKET . " where customers_id = '" . $cID . "'");
        xtc_db_query("delete from " . TABLE_CUSTOMERS_BASKET_ATTRIBUTES . " where customers_id = '" . $cID . "'");
        xtc_db_query("delete from " . TABLE_WHOS_ONLINE . " where customer_id = '" . $cID . "'");

        print_xml_status(0, $_POST['action'], 'OK', '', 'SQL_RES1', $res1);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function XsellUpdate() {
    global $_POST;

    $ProdID = xtc_db_prepare_input($_POST['prodid']);
    $XsellID = xtc_db_prepare_input($_POST['xsellid']);

    if (isset($ProdID) && isset($XsellID)) {

        // ueberpruefen ob Daten schon vorhanden sind
        $SQL = "select products_id, xsell_id from " . TABLE_PRODUCTS_XSELL . " where products_id='"
            . $ProdID . "' and xsell_id='" . $XsellID . "'";


        $count_query = xtc_db_query($SQL);
        $exists = xtc_db_fetch_array($count_query);
        if ($exists > 0) {
            $exists = 1;
            // Eintrag bereits vorhanden, tue nichts
        } else {
            $exists = 0;
            $res = xtc_db_query("replace into " . TABLE_PRODUCTS_XSELL . " (products_id, xsell_id) Values ('" . $ProdID . "', '" . $XsellID . "')");
        }

        print_xml_status(0, $_POST['action'], 'OK', '', 'SQL_RES', $res);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

//--------------------------------------------------------------

function XsellErase() {
    global $_POST;

    $ProdID = xtc_db_prepare_input($_POST['prodid']);
    $XsellID = xtc_db_prepare_input($_POST['xsellid']);

    if (isset($ProdID) && isset($XsellID)) {
        $res = xtc_db_query("delete from " . TABLE_PRODUCTS_XSELL . " where products_id='" . $ProdID . "' and xsell_id='" . $XsellID . "'");

        print_xml_status(0, $_POST['action'], 'OK', '', 'SQL_RES', $res);
    } else {
        print_xml_status(99, $_POST['action'], 'PARAMETER ERROR', '', '', '');
    }
}

function SetOrderStates() {

    $user = $_GET['user'];

    //Post-Daten komplett auslesen
    $xmlData = file_get_contents('php://input');
    $doc = new DOMDocument();
    $doc->loadXML($xmlData);
    if($doc == FALSE)
    {
        print_xml_status(99, $_GET['action'], "XML konnte nicht gelesen werden. Die Anfrage ist nicht gültig.");
        return;
    }

    //verfügbare Status laden
    $res = xtc_db_query("SELECT s.orders_status_id, s.orders_status_name "
                    . " FROM " . TABLE_ORDERS_STATUS . " s LEFT JOIN " . TABLE_LANGUAGES . " l ON(s.language_id = l.languages_id) "
                    . " WHERE l.code = 'de'");

    $orderStateIDsByName = array();

    while($row = xtc_db_fetch_array($res))
    {
        $ID = $row["orders_status_id"];
        $Name = $row["orders_status_name"];

        if(!empty($ID) && !empty($Name))
            $orderStateIDsByName[$Name] = $ID;
    }

    $orderStates = $doc->getElementsByTagName("OrderState");

    $results = array();

    foreach($orderStates as $orderState)
    {
        //Daten einlesen -> xmlGetValueFromChildNode prüft auf korrektheit
        $OrderId = XmlGetValueFromChildNode($orderState, "OrderID", true);
        $StateToApply = XmlGetValueFromChildNode($orderState, "State", true);
        $StateId = $orderStateIDsByName[$StateToApply];

        if(empty($StateId))
        {
            $error = array();
            $error['CODE']='-1';
            $error['CORRELATION_ID'] = $OrderId;
            $error['MESSAGE']="UPLOAD FAILED: Status '" . $StateToApply . "' existiert nicht.";
            array_push($results, $error);
            continue;
        }

        //Testen ob die Bestellung existiert
        $res = xtc_db_query("SELECT COUNT(*) AS Count FROM " . TABLE_ORDERS . " WHERE orders_id = '" . xtc_db_input($OrderId) . "'");
        $row = xtc_db_fetch_array($res);
        if(!$row && $row["Count"])
        {
            $error = array();
            $error['CODE']='-1';
            $error['CORRELATION_ID'] = $OrderId;
            $error['MESSAGE']="Bestellung " . $OrderId . " existiert nicht.";
            array_push($results, $error);
            continue;
        }

        //Datum in Datenbank-Konformes Format umwandeln
        $Date = XmlGetValueFromChildNode($orderState, "Date", true);
        $Date = strtotime($Date);
        $DbDate = date("Y-m-d H:i:s",$Date);

        //in die Bestellung eintragen
        xtc_db_query("UPDATE " . TABLE_ORDERS . " SET orders_status = " . xtc_db_input($StateId) . " WHERE orders_id = '" . xtc_db_input($OrderId) . "'");

        //Prüfen ob der Status bereits eingetragen wurde
        $res = xtc_db_query("SELECT COUNT(*) AS Count FROM " . TABLE_ORDERS_STATUS_HISTORY . " WHERE orders_id = '" . xtc_db_input($OrderId) . "' AND orders_status_id = '" . xtc_db_input($StateId) . "' AND date_added = '" . xtc_db_input($DbDate) . "'");
        $row = xtc_db_fetch_array($res);
        if(!$row && $row["Count"] > 0)
        {
            $status = array();
            $status['CODE'] = '0';
            $status['CORRELATION_ID'] = $OrderId;
            $status['MESSAGE'] = 'Status ' . $StateToApply . ' für Bestellung ' . $OrderId . ' übersprungen. Status wurde bereits eingetragen';
            array_push($results,$status);
            continue;
        }

        //In die Status_History eintragen
        $Comments = $data["comments"] = XmlGetValueFromChildNode($orderState, "Comments", false);
        xtc_db_query("INSERT INTO " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added,comments)"
                    ." VALUES ('" . xtc_db_input($OrderId) . "','" . xtc_db_input($StateId) . "','" . xtc_db_input($DbDate) . "','" . xtc_db_input($Comments) . "')");
    }

    print_xml_resultset_status(0, $_GET["action"], "", $results);
}

// Hinzugefügt am 27.02.2013 von CM: 
function ClearCache()
{
    if(class_exists("CacheControl",false))
    {
        $CacheCtrl = new CacheControl();
        $CacheCtrl->clear_data_cache();
        $CacheCtrl->clear_content_view_cache();
        $CacheCtrl->clear_templates_c();
        $CacheCtrl->clear_css_cache();
    }
    else
    {
        //Alle Dateien auser index.html und .htaccess aus den Ordnern cache und template_c löschen
        $exclude = array("index.html", ".htaccess");
        $result = true;

        if(!RemoveFilesInFolder(DIR_FS_DOCUMENT_ROOT . "cache", $exclude))
            $result = false;

        if(!RemoveFilesInFolder(DIR_FS_DOCUMENT_ROOT . "templates_c", $exclude))
           $result = false;

        if(!$result)
        {
            print_xml_status(99, $_POST['action'], 'FILEACCESS ERROR', '', '', '');
            return;
        }
    }
    
    print_xml_status(0, $_POST['action'], 'OK');
}

//--------------------------------------------------------------

function SendLog() {
    global $version_nr, $version_datum, $logger;

    SendHTMLHeader;

    echo '<html><head></head><body>';
    echo '<h3>Shoptransfer XTC<->CAO-Faktura</h3>';
    echo '<h4>Version ' . $version_nr . ' Stand : ' . $version_datum . '</h4>' .
    '<h4>Transfer-Log:</h4>';

    if (LOGGER == true) {
        $sql = 'select * from cao_log order by date desc limit 0,100';

        $res = xtc_db_query($sql);
        while ($log = xtc_db_fetch_array($res)) {
            echo 'Date:' . $log['date'] . '<br>' . "\n";
            echo 'Method:' . $log['method'] . '<br>' . "\n";
            echo 'Action:' . $log['action'] . '<br>' . "\n";
            echo 'Post-Data:<br>' . nl2br($log['post_data']) . '<br>' . "\n";
            echo 'Get-Data:<br>' . nl2br($log['get_data']) . '<br>' . "\n";

            echo "<hr>" . "\n";
        }
    } else {
        echo '<br><br><br><hr><h5>Der Logger wurde im Script deaktiviert !</h5><hr>';
    }

    echo '<br><br></body></html>';
}

// Geändert am 23.12.2010 von CM: weist ein Bild dem Produkt zu ( wird öfters im Code verwendet )
function link_image_to_product($name, $pId, $imgPos) {
    if (!empty($name)) {
        $image = xtc_db_prepare_input($name);

        $image_query = xtc_db_query("select image_id from " . TABLE_PRODUCTS_IMAGES .
                " where products_id='" . $pId . "' and " .
                "image_nr='" . $imgPos . "'");
        if ($image_res = xtc_db_fetch_array($image_query)) {
            //Bild existiert bereits
            $update_sql_data = array('products_id' => $pId,
                'image_nr' => $imgPos,
                'image_name' => $name);

            xtc_db_perform(TABLE_PRODUCTS_IMAGES, $update_sql_data, 'update', 'products_id = \'' . $pId . '\' and image_nr = \'' . $imgPos . '\'');
        } else {
            //Bild neu anlegen

            $insert_sql_data = array('products_id' => $pId,
                'image_nr' => $imgPos,
                'image_name' => $name);

            xtc_db_perform(TABLE_PRODUCTS_IMAGES, $insert_sql_data);
        }
    } else {
        $del = xtc_db_query("delete from " . TABLE_PRODUCTS_IMAGES . " where products_id='" . $pId . "' and " . "image_nr='" . $imgPos . "'");
    }
}

function XmlGetValueFromChildNode($parentNode, $childName, $AbortIfEmpty = false)
{
    $nodes = $parentNode->getElementsByTagName($childName);
    
    $action = $_POST['action'];
    if(empty($action))
        $action = $_GET['action'];

    if($nodes->length <= 0)
    {
        if($AbortIfEmpty)
        {
            print_xml_status(-1, $action, "UPLOAD FAILED: '" . $childName . "' konnte nicht gefunden werden.","","","");
            die();
        }else
            return "";
    }

    $value = $nodes->item(0)->nodeValue;

    if(empty($value) && $AbortIfEmpty)
    {
        print_xml_status(-1, $action, "UPLOAD FAILED: '" . $childName . "' enthält keinen gültigen Wert.","","","");
        die();
    }

    return xtc_db_prepare_input($value);
}

function GetNextIdFromTableWithoutAutoIncrement($Table, $PrimaryKeyColumn)
{
  $res = xtc_db_query("SELECT MAX(" . $PrimaryKeyColumn . ") AS maxid FROM " . $Table );
  if($row = xtc_db_fetch_array($res))
      return $row["maxid"]+1;

  return 0;
}

function RemoveFilesInFolder($Folder, $ExcludeFiles)
{
    if(empty($Folder) || !is_dir($Folder))
        return false;

    $result = true;
    $files = glob($Folder . "/*");

    foreach($files as $file)
    {
        if((!empty($ExcludeFiles) && in_array(basename($file), $ExcludeFiles)) || $file == "." || $file == "..")
            continue;
        
        if(is_dir($file))
            continue;

        if(!@unlink($file))
            $result = false;
    }
    
    return $result;
}

//--------------------------------------------------------------
//                     Ende Funktionen 
//--------------------------------------------------------------




$table_has_products_image_medium = false;
$table_has_products_image_large = false;

$images_query = xtc_db_query(' SHOW COLUMNS FROM ' . TABLE_PRODUCTS);
while ($column = xtc_db_fetch_array($images_query)) {
    if ($column['Field'] == 'products_image_medium') {
        $table_has_products_image_medium = true;
    }
    if ($column['Field'] == 'products_image_large') {
        $table_has_products_image_large = true;
    }
}
if ($table_has_products_image_medium && $table_has_products_image_large) {
    define('DREI_PRODUKTBILDER', true);
} else {
    define('DREI_PRODUKTBILDER', false);
}


if (LOGGER == true) {
    // log data into db.

    $pdata = '';
    while (list($key, $value) = each($_POST)) {
        if (is_array($value)) {
            while (list($key1, $value1) = each($value)) {
                $pdata .= addslashes($key) . "[" . addslashes($key1) . "] => " . addslashes($value1) . "\\r\\n";
            }
        } else {
            $pdata .= addslashes($key) . " => " . addslashes($value) . "\\r\\n";
        }
    }

    $gdata = '';
    while (list($key, $value) = each($_GET)) {
        $gdata .= addslashes($key) . " => " . addslashes($value) . "\\r\\n";
    }


    if ($_GET['action'] != 'send_log') {
        xtc_db_query("INSERT INTO cao_log
	                (date,user,pw,method,action,post_data,get_data) VALUES
	                (NOW(),'" . $user . "','" . $password . "','" . $REQUEST_METHOD . "','" . $_POST['action'] . "','" . $pdata . "','" . $gdata . "')");
    }
}




//-------------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------------

require_once(DIR_FS_INC . 'xtc_not_null.inc.php');
require_once(DIR_FS_INC . 'xtc_redirect.inc.php');
require_once(DIR_FS_INC . 'xtc_rand.inc.php');

//----------------------------------------------------------------------------
class upload {

    var $file, $filename, $destination, $permissions, $extensions, $tmp_filename;

    function upload($file = '', $destination = '', $permissions = '777', $extensions = '') {

        $this->set_file($file);
        $this->set_destination($destination);
        $this->set_permissions($permissions);
        $this->set_extensions($extensions);

        if (xtc_not_null($this->file) && xtc_not_null($this->destination)) {
            if (($this->parse() == true) && ($this->save() == true)) {
                return true;
            } else {
                return false;
            }
        }
    }

    //----------------------------------------------------------------------------
    function parse() {
        global $messageStack;
        if (isset($_FILES[$this->file])) {
            $file = array('name' => $_FILES[$this->file]['name'],
                'type' => $_FILES[$this->file]['type'],
                'size' => $_FILES[$this->file]['size'],
                'tmp_name' => $_FILES[$this->file]['tmp_name']);
        } elseif (isset($_FILES[$this->file])) {

            $file = array('name' => $_FILES[$this->file]['name'],
                'type' => $_FILES[$this->file]['type'],
                'size' => $_FILES[$this->file]['size'],
                'tmp_name' => $_FILES[$this->file]['tmp_name']);
        } else {
            $file = array('name' => $GLOBALS[$this->file . '_name'],
                'type' => $GLOBALS[$this->file . '_type'],
                'size' => $GLOBALS[$this->file . '_size'],
                'tmp_name' => $GLOBALS[$this->file]);
        }

        if (xtc_not_null($file['tmp_name']) && ($file['tmp_name'] != 'none') && is_uploaded_file($file['tmp_name'])) {
            if (sizeof($this->extensions) > 0) {
                if (!in_array(strtolower(substr($file['name'], strrpos($file['name'], '.') + 1)), $this->extensions)) {
                    //$messageStack->add_session(ERROR_FILETYPE_NOT_ALLOWED, 'error');

                    return false;
                }
            }

            $this->set_file($file);
            $this->set_filename($file['name']);
            $this->set_tmp_filename($file['tmp_name']);

            return $this->check_destination();
        } else {

            //if ($file['tmp_name']=='none') $messageStack->add_session(WARNING_NO_FILE_UPLOADED, 'warning');
            return false;
        }
    }

    //----------------------------------------------------------------------------
    function save() {
        global $messageStack;

        if (substr($this->destination, -1) != '/')
            $this->destination .= '/';

        // GDlib check
        if (!function_exists('imagecreatefromgif')) {

            // check if uploaded file = gif
            if ($this->destination == DIR_FS_CATALOG_ORIGINAL_IMAGES) {
                // check if merge image is defined .gif
                if (strstr(PRODUCT_IMAGE_THUMBNAIL_MERGE, '.gif') ||
                    strstr(PRODUCT_IMAGE_INFO_MERGE, '.gif') ||
                    strstr(PRODUCT_IMAGE_POPUP_MERGE, '.gif')) {

                    //$messageStack->add_session(ERROR_GIF_MERGE, 'error');
                    return false;
                }
                // check if uploaded image = .gif
                if (strstr($this->filename, '.gif')) {
                    //$messageStack->add_session(ERROR_GIF_UPLOAD, 'error');
                    return false;
                }
            }
        }

        if (move_uploaded_file($this->file['tmp_name'], $this->destination . $this->filename)) {
            chmod($this->destination . $this->filename, $this->permissions);

            //$messageStack->add_session(SUCCESS_FILE_SAVED_SUCCESSFULLY, 'success');

            return true;
        } else {
            //$messageStack->add_session(ERROR_FILE_NOT_SAVED, 'error');

            return false;
        }
    }

    //----------------------------------------------------------------------------
    function set_file($file) {
        $this->file = $file;
    }

    //----------------------------------------------------------------------------
    function set_destination($destination) {
        $this->destination = $destination;
    }

    //----------------------------------------------------------------------------
    function set_permissions($permissions) {
        $this->permissions = octdec($permissions);
    }

    //----------------------------------------------------------------------------
    function set_filename($filename) {
        $this->filename = $filename;
    }

    //----------------------------------------------------------------------------
    function set_tmp_filename($filename) {
        $this->tmp_filename = $filename;
    }

    //----------------------------------------------------------------------------
    function set_extensions($extensions) {
        if (xtc_not_null($extensions)) {
            if (is_array($extensions)) {
                $this->extensions = $extensions;
            } else {
                $this->extensions = array($extensions);
            }
        } else {
            $this->extensions = array();
        }
    }

    //----------------------------------------------------------------------------
    function check_destination() {
        global $messageStack;

        if (!is_writeable($this->destination)) {
            if (is_dir($this->destination)) {
                //$messageStack->add_session(sprintf(ERROR_DESTINATION_NOT_WRITEABLE, $this->destination), 'error');
            } else {
                //$messageStack->add_session(sprintf(ERROR_DESTINATION_DOES_NOT_EXIST, $this->destination), 'error');
            }

            return false;
        } else {
            return true;
        }
    }

}
?>
